PROGRAM fcar_simulation

!
 INCLUDE 'CXML_INCLUDE.F90'     !necessary if using Compaq Visual Fortran
!                                 !includes BLAS libraries in compilation.
!  
!  USE define_types
!   USE f90_utilities
!   USE stat_utilities
!   USE ts_utilities
!  USE nlts_utilities
!  USE fcar_interfaces
   USE MSIMSL
!-----------------------------------------------------------------------
!  Declare variables
!-----------------------------------------------------------------------
!  Parameters.  IF larger sizes are needed, make changes here.  They
!  will carry throughout remainder of programs.
!  max_n: Largest allowable sample size ((n + extra) .LE. max_n).
!         Also serves as maximum number of bootstrap replications.
!  max_k: Largest allowable number of components in the vector 
!         time series - NOTE: IF max_k is > 9, change I1 in FORMAT
!         statements 10 and 20 at END of program to be IX where X is
!         the number of digits in max_k (k .LE max_k).
!  max_p: Largest allowable AR order in all models (p .LE max_p).
!  max_q: Largest allowable MA order in all models (q .LE max_q).
!  max_no_regimes:  Largest allowable number of regimes in TAR model
!                   (no_regimes .LE. max_no_regimes).
!  max_ns: Largest allowable number of sample sizes for study in 
!          simulation
!  max_corrs: Largest allowable number of error cross-correlations for
!             study in simulation.
!  bw_q: Number of subsections of data in bandwidth selection.
!  nh : Number of bandwidths to consider in optimal bandwidth selection.
!-----------------------------------------------------------------------
  INTEGER, PARAMETER :: max_n = 600, max_k = 2
  INTEGER, PARAMETER :: max_p = 1, max_q = 5
  INTEGER, PARAMETER :: bw_q = 4, nh = 50
  INTEGER, DIMENSION(1) :: ind

  CHARACTER(30) :: outfile
!-----------------------------------------------------------------------
!  Simulation variables and arrays:
!-----------------------------------------------------------------------
  INTEGER :: i, j, l, no_ns, no_corrs, corr_no, n_no, no_bws, bw_no
  INTEGER :: no_reps, rep_no
  REAL RR(66,2)
 
!-----------------------------------------------------------------------
!  Variables needed for all models:
!-----------------------------------------------------------------------
  INTEGER :: n, k, p, q
!-----------------------------------------------------------------------
!  Vector time series realization matrix:
!-----------------------------------------------------------------------
  INTEGER :: t, dim, beta_dim
  REAL, DIMENSION(max_n, max_k) :: x
!-----------------------------------------------------------------------
!  Functional variable fitting:
!-----------------------------------------------------------------------
  INTEGER :: smoother, start, index_of_u
  INTEGER, DIMENSION(max_n) :: u_index
  REAL :: opt_bw, trim
  REAL, DIMENSION(max_n) :: func_var, u
  REAL, DIMENSION(2*max_n) :: z
  REAL, DIMENSION(max_n, max_k) :: y, y_s
  REAL, DIMENSION(max_n, max_k*max_p+1) :: xr, xr_s
  REAL, DIMENSION(max_n, max_p*max_k, max_k) :: f_hat, f_hat_s
!-----------------------------------------------------------------------
!  Bootstrap variables:
!-----------------------------------------------------------------------
  INTEGER :: no_bs_reps
  REAL :: rss0_det, rss1_det, T0, p_value
  REAL, DIMENSION(max_n) :: ts_star
  REAL, DIMENSION(max_k, max_k) :: rss0, rss1
  REAL, DIMENSION(max_n, max_k) :: y0_hat, y1_hat
  REAL, DIMENSION(max_n, max_k) :: y0_hat_s, y1_hat_s
  REAL, DIMENSION(max_k*max_p+1, max_k) :: beta_hat
!-----------------------------------------------------------------------
!  Bandwidth selection variables:
!-----------------------------------------------------------------------
  REAL :: range, step, band_width
  REAL, DIMENSION(nh+1) :: ams, bw_vec
!------------------------------------------------------------
!  input file
!------------------------------------------------------------
!     write(*,*) " k,nob?"
      k =2
      nr = 66
!      read(*,*) k,nob
!!      write(*,*) "Name of input file?"
!!    read(*,*) infile
!!    open(10,file=infile)
!!    do i = 1,nr
!!    read(10,*) (rr(i,j), j = 1,k)
!!    write(*,*) rr(i,j),i,j
!!    enddo
!!    close(10)

rr(1,1)=52.0750000000000
rr(2,1)=51.6333333333333
rr(3,1)=53.5666666666667
rr(4,1)=55.8750000000000
rr(5,1)=52.5250000000000
rr(6,1)=54.2583333333333
rr(7,1)=51.8416666666667
rr(8,1)=55.0583333333333
rr(9,1)=53.5250000000000
rr(10,1)=51.9416666666667
rr(11,1)=52.5083333333333
rr(12,1)=50.4000000000000
rr(13,1)=53.6333333333333
rr(14,1)=53.0750000000000
rr(15,1)=55.7666666666667
rr(16,1)=54
rr(17,1)=52.3166666666667
rr(18,1)=53.1000000000000
rr(19,1)=53.1166666666667
rr(20,1)=55.5083333333333
rr(21,1)=53.9833333333333
rr(22,1)=53.1416666666667
rr(23,1)=52.8916666666667
rr(24,1)=52.3750000000000
rr(25,1)=53.2250000000000
rr(26,1)=52.3083333333333
rr(27,1)=51.1833333333333
rr(28,1)=56.4166666666667
rr(29,1)=52.2583333333333
rr(30,1)=53.7916666666667
rr(31,1)=52.1666666666667
rr(32,1)=52.2250000000000
rr(33,1)=53.5916666666667
rr(34,1)=55.1000000000000
rr(35,1)=52.7250000000000
rr(36,1)=53.8250000000000
rr(37,1)=55.8916666666667
rr(38,1)=53.1166666666667
rr(39,1)=55.0333333333333
rr(40,1)=53.5500000000000
rr(41,1)=53.7000000000000
rr(42,1)=53.0666666666667
rr(43,1)=52.7833333333333
rr(44,1)=55.9833333333333
rr(45,1)=53.6833333333333
rr(46,1)=53.8000000000000
rr(47,1)=54.6166666666667
rr(48,1)=54.9833333333333
rr(49,1)=52.2583333333333
rr(50,1)=52.6416666666667
rr(51,1)=53.0250000000000
rr(52,1)=54.1416666666667
rr(53,1)=54.9250000000000
rr(54,1)=54.9750000000000
rr(55,1)=54.3083333333333
rr(56,1)=53.6500000000000
rr(57,1)=53.3750000000000
rr(58,1)=52.2833333333333
rr(59,1)=51.9416666666667
rr(60,1)=54.3250000000000
rr(61,1)=53.5250000000000
rr(62,1)=54.3000000000000
rr(63,1)=54.6416666666667
rr(64,1)=54.9750000000000
rr(65,1)=53.9833333333333
rr(66,1)=54.1250000000000

rr(1,2)=44
rr(2,2)=44
rr(3,2)=57
rr(4,2)=47
rr(5,2)=50
rr(6,2)=43
rr(7,2)=54
rr(8,2)=39
rr(9,2)=34
rr(10,2)=49
rr(11,2)=54
rr(12,2)=50
rr(13,2)=43
rr(14,2)=44
rr(15,2)=56
rr(16,2)=54
rr(17,2)=57
rr(18,2)=61
rr(19,2)=52
rr(20,2)=43
rr(21,2)=63
rr(22,2)=61
rr(23,2)=72
rr(24,2)=72
rr(25,2)=43
rr(26,2)=76
rr(27,2)=71
rr(28,2)=61
rr(29,2)=63
rr(30,2)=72
rr(31,2)=55
rr(32,2)=46
rr(33,2)=63
rr(34,2)=55
rr(35,2)=66
rr(36,2)=66
rr(37,2)=51
rr(38,2)=60
rr(39,2)=64
rr(40,2)=54
rr(41,2)=56
rr(42,2)=67
rr(43,2)=73
rr(44,2)=52
rr(45,2)=59
rr(46,2)=69
rr(47,2)=70
rr(48,2)=51
rr(49,2)=67
rr(50,2)=61
rr(51,2)=62
rr(52,2)=56
rr(53,2)=59
rr(54,2)=51
rr(55,2)=59
rr(56,2)=32
rr(57,2)=31
rr(58,2)=55
rr(59,2)=57
rr(60,2)=69
rr(61,2)=60
rr(62,2)=53
rr(63,2)=55
rr(64,2)=64
rr(65,2)=68
rr(66,2)=60
 
  
!-----------------------------------------------------------------------
!  END declare variables.
!  Begin user input.
!-----------------------------------------------------------------------
!
  WRITE(*,*) "What is the name of the output file?"
  READ(*,*) outfile
!
  OPEN(100,file=outfile)

 no_ns =1
 extra = 0

 means = 0
 intercept_option =1
 plusone=1
 trim =10
 alpha= 5
 AR_fit_order =1
 p = 1
! max_p = 1
 n = 66
 
! -----------------------------------------------------------------------
!   Functional variable loop (response index and delay):
!-----------------------------------------------------------------------
           IF(intercept_option == 1) xr(1:n,1) = 1.0
           no_cols = k*AR_fit_order + plusone
           DO func_resp_ind = 1, k
              band_width = 0.0
              DO func_delay = 1, MAX(p,1)
                 max_lag = MAX(AR_fit_order, func_delay)
                 no_obs = n - max_lag
                 y(1:no_obs,1:k) = RR((max_lag+1):n,1:k)                 
                 DO i = 1,AR_fit_order
                    xr(1:no_obs,(k*(i-1)+(1+plusone)):(i*k+plusone)) = &
					    RR((max_lag-i+1):(n-i),1:k)
		 write(100,*) xr(1:no_obs,(k*(i-1)+(1+plusone)):(i*k+plusone))
                 END DO
                 write(100,*)
!
                 beg_sub = 1 + max_lag - func_delay
                 end_sub = no_obs + max_lag - func_delay
                 func_var(1:no_obs) = RR(beg_sub:end_sub,func_resp_ind)
                 write(100,*) 'beg_sub', beg_sub,end_sub,max_lag,func_delay,func_resp_ind
                 do i=1,no_obs
                     write(100,*) func_var(i),i
                 end do
!-----------------------------------------------------------------------
!   Compute fitted values from linear regression:
!-----------------------------------------------------------------------
                 beta_dim = max_k*max_p+1
                 write(100,*)
                 CALL ls_regr_rmv(max_n,no_obs,k,no_cols,xr,y,beta_dim,beta_hat)
                 write(100,*) beta_hat(1:no_cols,1:k)
                 write(100,*)
                 y0_hat(1:no_obs,1:k) = MATMUL(xr(1:no_obs,1:no_cols),beta_hat(1:no_cols,1:k))
                 write(100,*) 'y0_hat1', y0_hat(1:no_obs,1:1),no_obs,k,beta_dim
                 write(100,*)
                 write(100,*) 'y0_hat2', y0_hat(1:no_obs,2:2),no_obs,k,beta_dim
                 write(100,*)
                   do i=1,n
		     write(100,*) 'func_var in main', func_var(i),i
		   end do
  
!-----------------------------------------------------------------------
!   Compute bandwidth, fit FCAR model to data, and compute fitted
!   values from FCAR model.
!-----------------------------------------------------------------------
                 CALL fcar_bandwidth(max_n,no_obs,k,no_cols,max_p*max_k,y,xr, &
                      func_var,func_var,3,nh,bw_q,ams,bw_vec)
                 ind = MINLOC(ams)
                 opt_bw = bw_vec(ind(1))

! write(100,*) 'par', max_n,no_obs,k,no_cols,y,xr
write(100,*) 
                 write(100,*) 'bandw ', opt_bw
              
                
                 CALL fit_fcar(max_n,no_obs,k,no_cols,y,xr,opt_bw,func_var,   &
                      func_var,3,0,no_obs,max_p*max_k,f_hat)
                 y1_hat(1:no_obs,1:k) = 0.0
                 DO j = 1, no_obs
                 DO l = 1, no_cols
                    y1_hat(j,1:k) = y1_hat(j,1:k) + xr(j,l)*f_hat(j,l,1:k)
!                    write(*,*) f_hat(j,l,1:k),j,l,k
!                    write(*,*) y1_hat(j,1:k),j,l
                    
                 END DO
                 END DO
!-----------------------------------------------------------------------
!   Sort values according to the ordered values of the functional
!   variable.
!-----------------------------------------------------------------------
                 DO i = 1, no_obs
                    u_index(i) = i
                 END DO
                 z(1:no_obs) = u(1:no_obs)
                 CALL i_sort(no_obs,u,u_index,z)
                 DO i = 1, no_obs
                    index_of_u = u_index(i)
                    y_s(i,1:k) = y(index_of_u,1:k)
                    y0_hat_s(i,1:k) = y0_hat(index_of_u,1:k)
                    y1_hat_s(i,1:k) = y1_hat(index_of_u,1:k)
                    xr_s(i,1:no_cols) = xr(index_of_u,1:no_cols)
                 END DO
!
                 y0_hat_s(1:no_obs,1:k) = y_s(1:no_obs,1:k) - y0_hat_s(1:no_obs,1:k)
                 y1_hat_s(1:no_obs,1:k) = y_s(1:no_obs,1:k) - y1_hat_s(1:no_obs,1:k)
                 T0 = 0.0
                 CALL fcar_test(max_n,max_k,no_obs,k,trim,y0_hat_s,y1_hat_s, &
                      rss0,rss1,rss0_det,rss1_det,T0)
!
!  The unsorted y1_hats are replaced with the residuals from the FCAR model
!  for use in bootstrap_test.
!
                 y1_hat(1:no_obs,1:k) = y(1:no_obs,1:k) - y1_hat(1:no_obs,1:k)

              END DO            ! End func_delay loop
           END DO               ! End func_resp_ind loop

  CLOSE(100)

!-----------------------------------------------------------------------
END PROGRAM fcar_simulation


SUBROUTINE fcar_bandwidth(max_n,  n,   k, p,       f_dim,    y,x,u,z,smoother,nh,bw_q,ams,bw_vec)
!l328 CALL fcar_bandwidth(max_n,no_obs,k,no_cols,max_p*max_k,y,xr,func_var,func_var,3,nh,bw_q,ams,bw_vec)


!***********************************************************************
!  FORTRAN 90 subroutine to compute the band width for FCAR modelling.
!  Notes: Uses BLAS function ddot and subroutine dgemv.  Both are
!         available for free download from http://www.netlib.org/blas/
!***********************************************************************
!  USE define_types
!
  IMPLICIT NONE
  INTEGER, INTENT(in) :: max_n, n, k, p, f_dim, smoother, bw_q, nh
  REAL, INTENT(in), DIMENSION(max_n) :: u, z
  REAL, INTENT(in), DIMENSION(max_n, k) :: y
  REAL, INTENT(in), DIMENSION(max_n, p) :: x
  REAL, INTENT(inout), DIMENSION(nh+1) :: bw_vec, ams
!
  INTEGER :: m, n1, i, j, t, jj
  REAL :: dn, h, sse, maxu, minu, range_of_u, a, step
  REAL, DIMENSION(max_n,f_dim,k) :: f_hat
  REAL, DIMENSION(k) :: err, y_hat
!
  dn = DBLE(n)
!  m = INT(0.1*dn)
  m=7
  ams = 0.0
  maxu = MAXVAL(u(1:n))
  minu = MINVAL(u(1:n))
  
  do i=1,n
    write(100,*) 'u and z in bandw', u(i),z(i),i
  end do
  
  range_of_u = maxu - minu
  a = 1.0/(DBLE(n)**0.20)
  step = range_of_u*a*1.5/(DBLE(nh))
  bw_vec(1) = 0.5*range_of_u*a
  write(100,*) 'bw_vec1', bw_vec(1)
  DO i = 2, nh+1
     bw_vec(i) = bw_vec(i-1) + step
     write(100,*) 'bw_vec ', bw_vec(i),i
  END DO
  write(100,*)
  write(100,*) 'p1: nh,m, n',n,nh,m,dn,a,step,maxu,minu,range_of_u
!
  DO i = 1,bw_q
     n1 = n - i*m
     DO j = 1,nh+1
        h = bw_vec(j) * (dn/DBLE(n1))**0.2
        write(100,*) 'h in bandw ', h,dn,n1
        write(100,*)
        write(100,*) 'within bandw befor fit', max_n,n1,k,p,smoother
        CALL fit_fcar(max_n,n1,k,p,y,x,h,u,z,smoother,n1,m,f_dim,f_hat)
        DO t = n1+1, n1+m
!        write(100,*) 't etc. ', t, n1,i,j,p,k,m
!        write(100,*) 'x ', x(t,1:p)
!        write(100,*) 'fhat ', f_hat(t,1:p,1:k)
           y_hat = MATMUL(x(t,1:p),f_hat(t,1:p,1:k))
           write(100,*) 'yhat within bandw after fit', y_hat
           
           err(1:k) = y(t,1:k) - y_hat(1:k)
           DO jj = 1, k
              ams(j) = ams(j) + err(jj)*err(jj)
           END DO
        END DO
     END DO
  END DO
!
RETURN
END SUBROUTINE fcar_bandwidth



MODULE stat_utilities
!***********************************************************************
!   FORTRAN 90 module containing commonly used statistical computations.
!
!   Created: 03/01/03 JLH
!
!   LAPACK subroutines xpotrf, xgetrf, xgetri are used in some 
!   subroutines.  These subroutines are available for free download
!   from http://www.netlib.org/lapack/.
!
!   BLAS subroutines xgemv and xgemm are used for matrix - vector and
!   matrix-matrix multiplication.  These are available for free 
!   download from http://www.netlib.org/blas/ .
!
!   In the names of the subroutines above, the x should be replaced
!   with a "s" for single precision or a "d" for double precision.
!
!   Contents:
!        Suboutines for generating random numbers:
!            gen_uniform, gen_normal
!        Smoothing functions:
!             logistic_sm, exponential_sm, quad_log_sm, quartic_sm,
!             Epanechnikov, cubic_sm
!        Subroutines for linear regression:
!             ls_regr_r, ls_regr_d, ls_regr_rmv, ls_regr_dmv
!***********************************************************************
!  USE define_types
! USE f90_utilities
!
  IMPLICIT NONE
!***********************************************************************
!  Uniform(a,b) deviates:
!***********************************************************************
  INTERFACE gen_uniform
     MODULE PROCEDURE gen_uniform_r   ! , gen_uniform_d
  END INTERFACE ! rlc gen_uniform
!***********************************************************************
!  Normal(mean, variance) deviates:
!***********************************************************************
  INTERFACE gen_normal
     MODULE PROCEDURE gen_normal_r, gen_normal_d, gen_mvnormal_r   
         ! gen_mvnormal_d
  END INTERFACE ! rlc gen_normal
!***********************************************************************
!  Smoothing functions:
!***********************************************************************
!     Logistic:
!***********************************************************************
  INTERFACE logistic_sm
     MODULE PROCEDURE logistic_sm_r  ! , logistic_sm_d
  END INTERFACE ! rlc logistic_sm
!***********************************************************************
!     Exponential:
!***********************************************************************
  INTERFACE exponential_sm
     MODULE PROCEDURE exponential_sm_r  ! , exponential_sm_d
  END INTERFACE ! rlc exponential_sm
!***********************************************************************
!     Quadratic logarithm:
!***********************************************************************
  INTERFACE quad_log_sm
     MODULE PROCEDURE quad_log_sm_r  ! , quad_log_sm_d
  END INTERFACE ! rlc quad_log_sm
!***********************************************************************
!     Quartic:
!***********************************************************************
  INTERFACE quartic_sm
     MODULE PROCEDURE quartic_sm_r ! , quartic_sm_d
  END INTERFACE ! rlc quartic_sm
!***********************************************************************
!     Epanechnikov:
!***********************************************************************
  INTERFACE Epanechnikov
     MODULE PROCEDURE Epanechnikov_r  !, Epanechnikov_d
  END INTERFACE ! rlc Epanechnikov
!***********************************************************************
!      Cubic:
!***********************************************************************
  INTERFACE cubic_sm
     MODULE PROCEDURE cubic_sm_r   ! , cubic_sm_d
  END INTERFACE ! rlc cubic_sm
!***********************************************************************
!   Linear regression:
!***********************************************************************
  INTERFACE ls_regression
     MODULE PROCEDURE ls_regr_r, ls_regr_d, ls_regr_rmv  ! , ls_regr_dmv
  END INTERFACE ! rlc ls_regression
!
CONTAINS
!
  SUBROUTINE gen_uniform_r(a,b,n,x)
!***********************************************************************
!  FORTRAN 90 subroutine to generate n uniform(a,b) random variates.
!***********************************************************************
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: n
    REAL, INTENT(in) :: a, b
    REAL, INTENT(out), DIMENSION(n) :: x
!
    INTEGER :: i
    REAL :: c
!
    DO i = 1,n
       CALL RANDOM_NUMBER(c)
       x(i) = (b - a)*c + a
    END DO
!
    RETURN
  END SUBROUTINE gen_uniform_r
!
  SUBROUTINE gen_uniform_d(a,b,n,x)
!***********************************************************************
!  FORTRAN 90 subroutine to generate n uniform(a,b) random variates.
!***********************************************************************
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: n
    REAL, INTENT(in) :: a, b
    REAL, INTENT(out), DIMENSION(n) :: x
!
    INTEGER :: i
    REAL :: c
!
    DO i = 1,n
       CALL RANDOM_NUMBER(c)
       x(i) = (b - a)*c + a
    END DO
!
    RETURN
  END SUBROUTINE gen_uniform_d
!
  SUBROUTINE gen_normal_r(mean,variance,n,x)
!***********************************************************************
!  FORTRAN 90 subroutine to generate n N(mean,variance)
!  random variates.
!***********************************************************************
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: n
    REAL, INTENT(in) :: mean, variance
    REAL, INTENT(out), DIMENSION(n) :: x
!
    INTEGER :: nn, nnb2, i, i1, i2
    REAL :: s, y
    REAL, DIMENSION(2) :: r
!  
    nn = n - 1
    IF(2*(n/2) .EQ. n) nn = n
    IF(n .EQ. nn) go to 20
!
5   CALL gen_uniform(0.0,1.0,2,r)
    !
    r = 2.0*(r - 0.50)
    s = DOT_PRODUCT(r,r)
    !
    IF(s .GT. 1.0) go to 5
    y = SQRT(-2.0*(LOG(s)/s))
    !
    x(n) = r(1)*y
    IF(n .EQ. 1) go to 99
    !
20  CALL gen_uniform(0.0,1.0,nn,x)
    nnb2 = nn/2
    !
    DO i = 1, nnb2
       i2 = 2*i
       i1 = i2 - 1
12     r(1) = 2.0 * (x(i1) - 0.50)
       r(2) = 2.0 * (x(i2) - 0.50)
       s = DOT_PRODUCT(r,r)
       IF(s .LE. 1.0) go to 15
       CALL gen_uniform(0.0,1.0,2,x(i1:i2))
       go to 12
15     y = SQRT(-2.0 * (LOG(s)/s))
       x(i1) = y*r(1)
       x(i2) = y*r(2)
    END DO
    x = SQRT(variance)*x + mean
!
99  CONTINUE
    RETURN
!
  END SUBROUTINE gen_normal_r
!
  SUBROUTINE gen_normal_d(mean,variance,n,x)
!***********************************************************************
!  FORTRAN 90 subroutine to generate n N(mean,variance)
!  random variates.
!***********************************************************************
!   USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: n
    REAL, INTENT(in) :: mean, variance
    REAL, INTENT(out), DIMENSION(n) :: x
!
    INTEGER :: nn, nnb2, i, i1, i2
    REAL :: s, y
    REAL, DIMENSION(2) :: r
!  
    nn = n - 1
    IF(2*(n/2) .EQ. n) nn = n
    IF(n .EQ. nn) go to 20
!
5   CALL gen_uniform(0.0,1.0,2,r)
!
    r = 2.0*(r - 0.50)
    s = DOT_PRODUCT(r,r)
!
    IF(s .GT. 1.0) go to 5
    y = SQRT(-2.0*(LOG(s)/s))
    !
    x(n) = r(1)*y
    IF(n .EQ. 1) go to 99
!
20  CALL gen_uniform(0.0,1.0,nn,x)
    nnb2 = nn/2
!
    DO i = 1, nnb2
       i2 = 2*i
       i1 = i2 - 1
12     r(1) = 2.0 * (x(i1) - 0.50)
       r(2) = 2.0 * (x(i2) - 0.50)
       s = DOT_PRODUCT(r,r)
       IF(s .LE. 1.0) go to 15
       CALL gen_uniform(0.0,1.0,2,x(i1:i2))
       go to 12
15     y = SQRT(-2.0 * (LOG(s)/s))
       x(i1) = y*r(1)
       x(i2) = y*r(2)
    END DO
    x = SQRT(variance)*x + mean
!
99  CONTINUE
    RETURN
!
  END SUBROUTINE gen_normal_d
!**********************************************************************
!  Multivariate normal:
!***********************************************************************
!  FORTRAN 90 subroutine to generate random normal observations having
!  mean vector mu and covariance matrix cov.  If cov.fac.opt = 0, then
!  the matrix cov contains the Cholesky decomposition of the covariance
!  matrix.  Otherwise, the Cholesky decomposition will be found.
!
!  Input: mean: a k-vector containing the means
!         cov: a k x k matrix containing the covariance matrix if
!              cov_fac_option != 0, and containing the Cholesky
!              decomposition of the covariance matrix otherwise.
!         cov_fac_option: an integer indicating whether or not the
!               matrix cov is the Cholesky decomposition of the 
!               covariance matrix (if 0 then no; otherwise, yes)
!
!  Output: x: an n x k matrix of multivariate normal deviates.
!
!  Algorigthm: Generate k iid E ~ N(0,1)
!              cov = Cholesky decomposition of covariance matrix
!              x( ,1:k) = trans(cov)E + mean ~ MVN(mean,covariance)
!
!  NOTES: uses LAPACK subroutine spotrf (or dpotrf) to compute the 
!         Cholesky decomposition of the covariance matrix.  See
!         http://www.netlib/org/lapack/.
!***********************************************************************
  SUBROUTINE gen_mvnormal_r(max_n,max_k,n,k,mean,cov,cov_fac_option,x)
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_n, max_k, n, k, cov_fac_option
    REAL, INTENT(in), DIMENSION(k) :: mean
    REAL, INTENT(in), DIMENSION(max_k, k) :: cov
    REAL, INTENT(out), DIMENSION(max_n, k) :: x
!
    INTEGER :: info, i, j
    REAL, DIMENSION(:), ALLOCATABLE :: temp, temp_out
    REAL, DIMENSION(:,:), ALLOCATABLE :: cov_fac
!
    EXTERNAL spotrf
!
    ALLOCATE(cov_fac(k,k))
    cov_fac = cov
    DO i = 1, k
    DO j = 1, i-1
       cov_fac(i,j) = 0.0
    END DO
    END DO
!
    IF(cov_fac_option .NE. 0) CALL spotrf("U",k,cov_fac,k,info)
!
    ALLOCATE(temp(k))
    ALLOCATE(temp_out(k))
    DO i = 1,n
       CALL gen_normal_r(0.0,1.0,k,temp)
       temp = MATMUL(TRANSPOSE(cov_fac),temp)
       x(i,1:k) = temp_out + mean(1:k)
    END DO
    DEALLOCATE(temp, temp_out, cov_fac)
!
!print *, "MATMUL in stat_utilities.f90/gen_mvnormal_r(): OK"
    RETURN
  END SUBROUTINE gen_mvnormal_r
!
  SUBROUTINE gen_mvnormal_d(max_n,max_k,n,k,mean,cov,cov_fac_option,x)
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_n, max_k, n, k, cov_fac_option
    REAL, INTENT(in), DIMENSION(k) :: mean
    REAL, INTENT(in), DIMENSION(max_k, k) :: cov
    REAL, INTENT(inout), DIMENSION(max_n, k) :: x
!
    INTEGER :: info, i, j
    REAL, DIMENSION(:), ALLOCATABLE :: temp, temp_out
    REAL, DIMENSION(:,:), ALLOCATABLE :: cov_fac
!
    EXTERNAL dpotrf
!
    ALLOCATE(cov_fac(k,k))
    cov_fac = cov(1:k,1:k)
    DO i = 1, k
    DO j = 1, i-1
       cov_fac(i,j) = 0.0
    END DO
    END DO
!
    IF(cov_fac_option .NE. 0) CALL dpotrf("U",k,cov_fac,k,info)
!
    ALLOCATE(temp(k))
    ALLOCATE(temp_out(k))
    DO i = 1, n
       CALL gen_normal_r(0.0,1.0,k,temp)
       temp = MATMUL(TRANSPOSE(cov_fac),temp) 
       x(i,1:k) = temp + mean
    END DO
    DEALLOCATE(temp, temp_out, cov_fac)
!print *, "MATMUL in stat_utilities.f90/gen_mvnormal_d(): OK"
!
    RETURN
  END SUBROUTINE gen_mvnormal_d
!**********************************************************************
!  Smoothing functions:
!**********************************************************************
!    Logisitic:
!**********************************************************************
  FUNCTION logistic_sm_r(x, sm_constant, sm_PARAMETER)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x, sm_constant, sm_PARAMETER
    REAL :: logistic_sm_r
!
    logistic_sm_r = 1.0/(1.0 + EXP(-sm_PARAMETER*(x - sm_constant)))
!
    RETURN
  END FUNCTION logistic_sm_r
!
  FUNCTION logistic_sm_d(x, sm_constant, sm_PARAMETER)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x, sm_constant, sm_PARAMETER
    REAL :: logistic_sm_d
!
    logistic_sm_d = 1.0/(1.0 + EXP(-sm_PARAMETER*(x - sm_constant)))
!
    RETURN
  END FUNCTION logistic_sm_d
!**********************************************************************
!    Exponential:
!**********************************************************************
  FUNCTION exponential_sm_r(x, sm_constant, sm_PARAMETER)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x, sm_constant, sm_PARAMETER
    REAL :: exponential_sm_r
!
    exponential_sm_r = 1.0 - EXP(-sm_PARAMETER*(x - sm_constant)*(x - sm_constant))
!
    RETURN
  END FUNCTION exponential_sm_r
!
  FUNCTION exponential_sm_d(x, sm_constant, sm_PARAMETER)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x, sm_constant, sm_PARAMETER
    REAL :: exponential_sm_d
!
    exponential_sm_d = 1.0 - EXP(-sm_PARAMETER*(x - sm_constant)*(x - sm_constant))
!
    RETURN
  END FUNCTION exponential_sm_d
!**********************************************************************
!    Quadratic logarithm:
!**********************************************************************
  FUNCTION quad_log_sm_r(x, sm_constant, sm_PARAMETER)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x, sm_constant, sm_PARAMETER
    REAL :: quad_log_sm_r
!
    quad_log_sm_r = 1.0/(1.0 + EXP(sm_PARAMETER*(x*x - sm_constant*sm_constant)))
!
    RETURN
  END FUNCTION quad_log_sm_r
!
  FUNCTION quad_log_sm_d(x, sm_constant, sm_PARAMETER)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x, sm_constant, sm_PARAMETER
    REAL:: quad_log_sm_d
!
    quad_log_sm_d = 1.0/(1.0 + EXP(sm_PARAMETER*(x*x - sm_constant*sm_constant)))
!
    RETURN
  END FUNCTION quad_log_sm_d
!***********************************************************************
!    Cubic:
!***********************************************************************
  FUNCTION cubic_sm_r(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: cubic_sm_r
!
    IF(ABS(x) .LE. 1.0) THEN
       cubic_sm_r = 0.75*(1.0 - x*x)
    ELSE
       cubic_sm_r = 0.0
    END IF
!
    RETURN
  END FUNCTION cubic_sm_r
!
  FUNCTION cubic_sm_d(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: cubic_sm_d
!
    IF(ABS(x) .LE. 1.0) THEN
       cubic_sm_d = 0.75*(1.0 - x*x)
    ELSE
       cubic_sm_d = 0.0
    END IF
!
    RETURN
  END FUNCTION cubic_sm_d
!************************************************************************
!     Epanechnikov:
!***********************************************************************
  FUNCTION Epanechnikov_r(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: Epanechnikov_r
!
    IF((x*x) .LE. 0.5) THEN
       Epanechnikov_r = 3.0 * (1.0 - x**(2.0/5.0))
       Epanechnikov_r = Epanechnikov_r / (4.0*SQRT(5.0))
    ELSE
       Epanechnikov_r = 0.0
    END IF
!
    RETURN
  END FUNCTION Epanechnikov_r
!
  FUNCTION Epanechnikov_d(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: Epanechnikov_d
!
    IF((x*x) .LE. 0.5) THEN
       Epanechnikov_d = 3.0 * (1.0 - x**(2.0/5.0))
       Epanechnikov_d = Epanechnikov_d / (4.0*SQRT(5.0))
    ELSE
       Epanechnikov_d = 0.0
    END IF
!
    RETURN
  END FUNCTION Epanechnikov_d
!***********************************************************************
!      Quartic:
!***********************************************************************
  FUNCTION quartic_sm_r(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: quartic_sm_r
!
    IF(ABS(x) .LE. 1.0) THEN
       quartic_sm_r = 0.9375*(1.0 - x*x)*(1.0 - x*x)
    ELSE
       quartic_sm_r = 0.0
    END IF
!
    RETURN
  END FUNCTION quartic_sm_r
!
  FUNCTION quartic_sm_d(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: quartic_sm_d
!
    IF(ABS(x) .LE. 1.0) THEN
       quartic_sm_d = 0.9375*(1.0 - x*x)*(1.0- x*x)
    ELSE
       quartic_sm_d = 0.0
    END IF
!
    RETURN
  END FUNCTION quartic_sm_d
!***********************************************************************
!  Linear regression:
!***********************************************************************
!  Notes: Uses LAPACK subroutines sgetrf and sgetri for computing
!         LU factorization and matrix inversion.  See
!         http://www.netlib.org/lapack/
!***********************************************************************
  SUBROUTINE ls_regr_r(max_n,n,p,x,y,beta_hat)
!    USE define_types
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, n, p
    REAL, INTENT(in), DIMENSION(n) :: y
    REAL, INTENT(in), DIMENSION(max_n, p) :: x
    REAL, INTENT(out), DIMENSION(p) :: beta_hat
!
    INTEGER :: info
    INTEGER, DIMENSION(:), ALLOCATABLE :: pivot
    REAL, DIMENSION(:), ALLOCATABLE :: xty
    REAL, DIMENSION(:,:), ALLOCATABLE :: xtx
    REAL, DIMENSION(:), ALLOCATABLE :: work_space
!
    EXTERNAL sgetrf
    EXTERNAL sgetri
!
    ALLOCATE(xtx(p,p))
    ALLOCATE(xty(p))
    xtx = MATMUL(TRANSPOSE(x(1:n,1:p)),x(1:n,1:p))
    xty = MATMUL(TRANSPOSE(x(1:n,1:p)),y(1:n))
!
    ALLOCATE(pivot(p))
    ALLOCATE(work_space(p))
    CALL sgetrf(p,p,xtx,p,pivot,info)
    CALL sgetri(p,xtx,p,pivot,work_space,p,info)
    DEALLOCATE(pivot, work_space)
!
    beta_hat(1:p) = MATMUL(xtx(1:p,1:p),xty(1:p))
!
!print *, "MATMUL (2) in stat_utilities.f90/ls_regr_r(): OK"
    DEALLOCATE(xtx, xty)
    RETURN
  END SUBROUTINE ls_regr_r
!
  SUBROUTINE ls_regr_d(max_n,n,p,x,y,beta_hat)
!    USE define_types
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, n, p
    REAL, INTENT(in), DIMENSION(n) :: y
    REAL, INTENT(in), DIMENSION(max_n, p) :: x
    REAL, INTENT(out), DIMENSION(p) :: beta_hat
!
    INTEGER :: info
    INTEGER, DIMENSION(:), ALLOCATABLE :: pivot
    REAL, DIMENSION(:), ALLOCATABLE :: xty, work_space
    REAL, DIMENSION(:,:), ALLOCATABLE :: xtx

!
    EXTERNAL dgetrf
    EXTERNAL dgetri
!
    ALLOCATE(xtx(p,p))
    ALLOCATE(xty(p))
    xtx = MATMUL(TRANSPOSE(x(1:n,1:p)),x(1:n,1:p))
    xty = MATMUL(TRANSPOSE(x(1:n,1:p)),y(1:n))
!
    ALLOCATE(pivot(p))
    ALLOCATE(work_space(p))
    CALL dgetrf(p,p,xtx,p,pivot,info)
    CALL dgetri(p,xtx,p,pivot,work_space,p,info)
    DEALLOCATE(pivot, work_space)
!
    beta_hat(1:p) = MATMUL(xtx(1:p,1:p),xty(1:p))
!
    DEALLOCATE(xtx, xty)
    RETURN
  END SUBROUTINE ls_regr_d
!
  SUBROUTINE ls_regr_rmv(max_n,n,k,p,x,y,beta_dim,beta_hat)
!    USE define_types
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, n, k, beta_dim, p
    REAL, INTENT(in), DIMENSION(max_n, p) :: x
    REAL, INTENT(in), DIMENSION(max_n, k) :: y
    REAL, INTENT(inout), DIMENSION(beta_dim, k) :: beta_hat
!
    INTEGER :: info
    INTEGER, DIMENSION(:), ALLOCATABLE :: pivot
    REAL, DIMENSION(:), ALLOCATABLE :: work_space
    REAL, DIMENSION(:,:), ALLOCATABLE :: xtx, xty
!
    EXTERNAL sgetrf
    EXTERNAL sgetri
!
    ALLOCATE(xtx(p,p))
    ALLOCATE(xty(p,k))
    write(100,*) 'x ',  x
    
    xtx = MATMUL(TRANSPOSE(x(1:n,1:p)),x(1:n,1:p))
    write(100,*) 'xtx ', xtx
    xty = MATMUL(TRANSPOSE(x(1:n,1:p)),y(1:n,1:k))
!
    ALLOCATE(pivot(p))
    ALLOCATE(work_space(p))
    CALL sgetrf(p,p,xtx,p,pivot,info)
    CALL sgetri(p,xtx,p,pivot,work_space,p,info)
    DEALLOCATE(pivot, work_space)
!
    beta_hat(1:p,1:k) = MATMUL(xtx(1:p,1:p),xty(1:p,1:k))
!print *, "MATMUL (3) in stat_utilities.f90/ls_regr_rmv(): OK"
!
    DEALLOCATE(xtx, xty)
    RETURN
!
  END SUBROUTINE ls_regr_rmv
!
  SUBROUTINE ls_regr_dmv(max_n,n,k,p,x,y,beta_dim,beta_hat)
!    USE define_types
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, n, k, beta_dim, p
    REAL, INTENT(in), DIMENSION(max_n, p) :: x
    REAL, INTENT(in), DIMENSION(max_n, k) :: y
    REAL, INTENT(inout), DIMENSION(beta_dim, k) :: beta_hat
!
    INTEGER :: info
    INTEGER, DIMENSION(:), ALLOCATABLE :: pivot
    REAL, DIMENSION(:), ALLOCATABLE :: work_space
    REAL, DIMENSION(:,:), ALLOCATABLE :: xtx, xty
!
    EXTERNAL dgetrf
    EXTERNAL dgetri
!
    ALLOCATE(xtx(p,p))
    ALLOCATE(xty(p,k))
    xtx = MATMUL(TRANSPOSE(x(1:n,1:p)),x(1:n,1:p))
    xty = MATMUL(TRANSPOSE(x(1:n,1:p)),y(1:n,1:k))
!
    ALLOCATE(pivot(p))
    ALLOCATE(work_space(p))
    CALL dgetrf(p,p,xtx,p,pivot,info)
    CALL dgetri(p,xtx,p,pivot,work_space,p,info)
    DEALLOCATE(pivot, work_space)
!
    beta_hat(1:p,1:k) = MATMUL(xtx,xty)
!print *, "MATMUL (2) in stat_utilities.f90/ls_regr_dmv(): OK"
!
    DEALLOCATE(xtx,xty)
    RETURN
!
  END SUBROUTINE ls_regr_dmv
!
END MODULE stat_utilities

MODULE stat_interfaces
!***********************************************************************
!  FORTRAN 90 module containing interfaces for statistics utilities in
!  stat_utilities.f90.
!
!  Created: 03/01/03 JLH
!***********************************************************************
  INTERFACE
     SUBROUTINE gen_uniform_r(a,b,n,x)
 !     USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: n
       REAL, INTENT(in) :: a, b
       REAL, INTENT(out), DIMENSION(n) :: x
     END SUBROUTINE gen_uniform_r
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_uniform_d(a,b,n,x)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: n
       REAL, INTENT(in) :: a, b
       REAL, INTENT(out), DIMENSION(n) :: x
     END SUBROUTINE gen_uniform_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_normal_r(mean,variance,n,x)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: n
       REAL, INTENT(in) :: mean, variance
       REAL, INTENT(out), DIMENSION(n) :: x
     END SUBROUTINE gen_normal_r
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_normal_d(mean,variance,n,x)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: n
       REAL,INTENT(in) :: mean, variance
       REAL, INTENT(out), DIMENSION(n) :: x
     END SUBROUTINE gen_normal_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_mvnormal_r(max_n,max_k,n,k,mean,cov,cov_fac_option,x)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, max_k, n, k, cov_fac_option
       REAL, INTENT(in), DIMENSION(k) :: mean
       REAL, INTENT(in), DIMENSION(max_k, k) :: cov
       REAL, INTENT(out), DIMENSION(max_n, k) :: x
       EXTERNAL spotrf
     END SUBROUTINE gen_mvnormal_r
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_mvnormal_d(max_n,max_k,n,k,mean,cov,cov_fac_option,x)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, max_k, n, k, cov_fac_option
       REAL, INTENT(in), DIMENSION(k) :: mean
       REAL, INTENT(in), DIMENSION(max_k, k) :: cov
       REAL, INTENT(inout), DIMENSION(max_n, k) :: x
       EXTERNAL dpotrf
     END SUBROUTINE gen_mvnormal_d
  END INTERFACE
!
  INTERFACE
     FUNCTION logistic_sm_r(x, sm_constant, sm_PARAMETER)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: sm_constant, sm_PARAMETER, x
       REAL :: logistic_sm_r
     END FUNCTION logistic_sm_r
  END INTERFACE
!
  INTERFACE
     FUNCTION logistic_sm_d(x, sm_constant, sm_PARAMETER)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: sm_constant, sm_PARAMETER, x
       REAL :: logistic_sm_d
     END FUNCTION logistic_sm_d
  END INTERFACE
!
  INTERFACE
     FUNCTION exponential_sm_r(x, sm_constant, sm_PARAMETER)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: sm_constant, sm_PARAMETER, x
       REAL :: exponential_sm_r
     END FUNCTION exponential_sm_r
  END INTERFACE
!
  INTERFACE
     FUNCTION exponential_sm_d(x, sm_constant, sm_PARAMETER)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: sm_constant, sm_PARAMETER, x
       REAL :: exponential_sm_d
     END FUNCTION exponential_sm_d
  END INTERFACE
!
  INTERFACE
     FUNCTION quad_log_sm_r(x, sm_constant, sm_PARAMETER)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: sm_constant, sm_PARAMETER, x
       REAL :: quad_log_sm_r
     END FUNCTION quad_log_sm_r
  END INTERFACE
!
  INTERFACE
     FUNCTION quad_log_sm_d(x, sm_constant, sm_PARAMETER)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: sm_constant, sm_PARAMETER, x
       REAL :: quad_log_sm_d
     END FUNCTION quad_log_sm_d
  END INTERFACE
!
  INTERFACE
     FUNCTION cubic_sm_r(x)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: x
       REAL :: cubic_sm_r
     END FUNCTION cubic_sm_r
  END INTERFACE
!
  INTERFACE
     FUNCTION cubic_sm_d(x)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: x
       REAL :: cubic_sm_d
     END FUNCTION cubic_sm_d
  END INTERFACE
!
  INTERFACE
     FUNCTION Epanechnikov_r(x)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: x
       REAL :: Epanechnikov_r
     END FUNCTION Epanechnikov_r
  END INTERFACE
!
  INTERFACE
     FUNCTION Epanechnikov_d(x)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: x
       REAL :: Epanechnikov_d
     END FUNCTION Epanechnikov_d
  END INTERFACE
!
  INTERFACE
     FUNCTION quartic_sm_r(x)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: x
       REAL :: quartic_sm_r
     END FUNCTION quartic_sm_r
  END INTERFACE
!
  INTERFACE
     FUNCTION quartic_sm_d(x)
!      USE define_types
       IMPLICIT NONE
       REAL, INTENT(in) :: x
       REAL :: quartic_sm_d
     END FUNCTION quartic_sm_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE ls_regr_r(max_n,n,p,x,y,beta_hat)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, n, p
       REAL, INTENT(in), DIMENSION(n) :: y
       REAL, INTENT(in), DIMENSION(max_n, p) :: x
       REAL, INTENT(out), DIMENSION(p) :: beta_hat
       EXTERNAL sgetrf
       EXTERNAL sgetri
     END SUBROUTINE ls_regr_r
  END INTERFACE
!
  INTERFACE
     SUBROUTINE ls_regr_d(max_n,n,p,x,y,beta_hat)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, n, p
       REAL, INTENT(in), DIMENSION(n) :: y
       REAL, INTENT(in), DIMENSION(max_n, p) :: x
       REAL, INTENT(out), DIMENSION(p) :: beta_hat
       EXTERNAL dgetrf
       EXTERNAL dgetri
     END SUBROUTINE ls_regr_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE ls_regr_rmv(max_n,n,k,p,x,y,beta_dim,beta_hat)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, n, k, beta_dim, p
       REAL, INTENT(in), DIMENSION(max_n, p) :: x
       REAL, INTENT(in), DIMENSION(max_n, k) :: y
       REAL, INTENT(inout), DIMENSION(beta_dim, k) :: beta_hat
       EXTERNAL sgetrf
       EXTERNAL sgetri
     END SUBROUTINE ls_regr_rmv
  END INTERFACE
!
  INTERFACE
     SUBROUTINE ls_regr_dmv(max_n,n,k,p,x,y,beta_dim,beta_hat)
!      USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, n, k, beta_dim, p
       REAL, INTENT(in), DIMENSION(max_n, p) :: x
       REAL, INTENT(in), DIMENSION(max_n, k) :: y
       REAL, INTENT(inout), DIMENSION(beta_dim, k) :: beta_hat
       EXTERNAL dgetrf
       EXTERNAL dgetri
     END SUBROUTINE ls_regr_dmv
  END INTERFACE
!
END MODULE stat_interfaces


!***********************************************************************
!  Generate vector bilinear:
!***********************************************************************
!  Get coefficients:
!***********************************************************************
  SUBROUTINE get_mvbilinear_params(max_k,max_p,max_q,file_label,k,p,q,  &
       cp_option,AR_coefs,MA_coefs,cp_dim,cp_coefs)
!***********************************************************************
!  FORTRAN90 subroutine to get parameter values for generating 
!  multivariate bilinear time series.
!***********************************************************************
!    USE define_types
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_k, max_p, max_q, file_label, k
    INTEGER, INTENT(out) :: p, q, cp_option, cp_dim
    REAL, INTENT(out), DIMENSION(max_k, (max_k*max_p)**2) :: cp_coefs
    REAL, INTENT(out), DIMENSION(max_p, max_k, k) :: AR_coefs
    REAL, INTENT(out), DIMENSION(max_q, max_k, k) :: MA_coefs
!
    INTEGER :: lag, dim1, dim2
!
    WRITE(file_label,400) k
    WRITE(*,*) "Enter the AR order (p) and MA order (q)."
    WRITE(*,*) "p = ?"
    READ(*,*) p
    WRITE(*,*) "q = ?"
    READ(*,*) q
    WRITE(file_label,500) p, q
!
    IF(p > 0) THEN
       WRITE(*,*) "Enter the AR coefficients, row by row."
       WRITE(file_label,510) 
       DO lag = 1, p
          WRITE(*,520) lag
          WRITE(file_label,520) lag
          DO dim1 = 1, k
             READ(*,*) (AR_coefs(lag,dim1,dim2), dim2 = 1, k)
             WRITE(file_label,*) (AR_coefs(lag,dim1,dim2), dim2 = 1, k)
          END DO
       END DO
    END IF
!
    IF(q > 0) THEN
       WRITE(*,*) "Enter the MA coefficients, row by row."
       WRITE(file_label,530) 
       DO lag = 1, q
          WRITE(*,520) lag
          WRITE(file_label,520) lag
          DO dim1 = 1, k
             READ(*,*) (MA_coefs(lag,dim1,dim2), dim2 = 1, k)
             WRITE(file_label,*) (MA_coefs(lag,dim1,dim2), dim2 = 1, k)
          END DO
       END DO
    END IF
!
    WRITE(*,*) "What type of cross-product terms should be included?"
    WRITE(*,*) " 0 => no cross-product terms,"
    WRITE(*,*) " 1 => time series realizations with errors,"
    WRITE(*,*) " 2 => squared terms and interactions of time series, or"
    WRITE(*,*) " 3 => squared and cross-products of error terms."
    READ(*,*) cp_option
    WRITE(file_label,*)
!
    IF(cp_option == 0) THEN
       cp_dim = 1
       WRITE(file_label,540)
    ELSE IF(cp_option == 1) THEN
       WRITE(file_label,550)
       cp_dim = p*q*k*k
    ELSE IF(cp_option == 2) THEN
       WRITE(file_label,560)
       cp_dim = (p*k)*(p*k + 1)/2
    ELSE IF(cp_option == 3) THEN
       WRITE(file_label,570)
       cp_dim = (q*k)*(q*k + 1)/2
    END IF
    WRITE(file_label,*)
!
    WRITE(*,*) "Enter the coefficients for the second order terms (row by row)."
    WRITE(file_label,580)
    DO dim1 = 1, k
       READ(*,*) (cp_coefs(dim1,dim2), dim2 = 1, cp_dim)
       WRITE(file_label,*) (cp_coefs(dim1,dim2), dim2 = 1, cp_dim)
    END DO
!
400 FORMAT("Vector bilinear process of dimension ",I1,".")
500 FORMAT("AR order (p) = ",I2,": MA order (q) = ",I2,".")
510 FORMAT("The AR coefficients (row by row) are:")
520 FORMAT("Lag ",I2,":")
530 FORMAT("The MA coefficients (row by row) are:")
540 FORMAT("There are no cross-product terms.")
550 FORMAT("Cross-product terms were the time series with the errors.")
560 FORMAT("Cross-product terms were squared terms and interactions of the time series.")
570 FORMAT("Cross-product terms were squared errors and cross-products of errors.")
580 FORMAT("The second-order term coefficients are (row by row):")
!
    RETURN
  END SUBROUTINE get_mvbilinear_params
!***********************************************************************
!   Generate realization:
!***********************************************************************
  SUBROUTINE gen_mvbilinear(max_n,max_k,max_p,max_q,n,k,p,q,AR_coefs,   &
       MA_coefs,cp_option,cp_dim,cp_coefs,cov_fac_option,cov,extra,x)
!   USE define_types
!   USE f90_utilities, ONLY : vech
!   USE stat_utilities
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, max_k, max_p, max_q
    INTEGER, INTENT(in) :: n, k, p, q, cp_option, cp_dim
    INTEGER, INTENT(in) :: cov_fac_option, extra
    REAL, INTENT(in), DIMENSION(max_k, k) :: cov
    REAL, INTENT(in), DIMENSION(max_k, cp_dim) :: cp_coefs
    REAL, INTENT(in), DIMENSION(max_p, max_k, k) :: AR_coefs
    REAL, INTENT(in), DIMENSION(max_q, max_k, k) :: MA_coefs
    REAL, INTENT(inout), DIMENSION(max_n, k) :: x
!
    REAL, DIMENSION(max_n,k) :: eps
    INTEGER :: nn, dim, t, i, j, index1, index2, vech_option, jj, l, dim1, dim2
    REAL, DIMENSION(k) :: work_space
    REAL, DIMENSION((p*k)) :: zv
    REAL, DIMENSION(cp_dim) :: z
    REAL, DIMENSION(1,(p*k)) :: zvt
!
    work_space = 0.0
    eps = 0.0
    nn = n + extra
    dim = max(p,q)*k
    CALL gen_mvnormal_r(max_n,max_k,nn,k,work_space,cov,cov_fac_option,eps)
!
    x(1:nn,1:k) = eps(1:nn,1:k)
    DO t = 1, nn
!
!  Terms for computing cross-products:
!
       DO i = 1, k
          DO j = 1, MIN(t-1, p)
             index1 = t - j
             index2 = p*(i-1) + j
             IF(cp_option == 1) THEN
                zv(index2) = x(index1,i)
                zvt(1,index2) = eps(index1,i)
                vech_option = 1
             ELSE IF(cp_option == 2) THEN
                zv(index2) = x(t-j,i)
                zvt(1,index2) = zv(p*(i-1) + j)
                vech_option = 0
             ELSE IF(cp_option == 3) THEN
                zv(index2) = eps(index1,i)
                zvt(1,index2) = zv(index2)
                vech_option = 0
             END IF
             CALL vech_r(zv,zvt,dim,dim,1,dim,p*k,vech_option,z)
          END DO
       END DO
!
!  Linear AR part:
!
       DO j = 1, MIN(t-1, p)
          DO dim1 = 1, k
          DO dim2 = 1, k
             x(t,dim1) = x(t,dim1) + AR_coefs(j,dim1,dim2)*x(t-j,dim2)
          END DO
          END DO
       END DO
!
!  Linear MA part:
!
       DO j = 1, MIN(t-1, q)
          DO dim1 = 1, k
          DO dim2 = 1, k
             x(t,dim1) = x(t,dim1) - MA_coefs(j,dim1,dim2)*eps(t-j,dim2)
          END DO
          END DO
       END DO
!
!  Nonlinear part:
!
       DO i = 1, k
       DO j = 1, cp_dim
          x(t,i) = x(t,i) + cp_coefs(i,j)*z(j)
       END DO
       END DO
    END DO
!
    x(1:n,1:k) = x((extra+1):(extra+n),1:k)
!
    RETURN
  END SUBROUTINE gen_mvbilinear
!***********************************************************************
!  Generate vector threshold ARMA:
!***********************************************************************
!  Get coefficients:
!***********************************************************************
  SUBROUTINE get_mvTAR_params(max_k,max_p,max_q,max_no_regimes,       &
       file_label,k,p,q,no_regimes,TAR_AR_coefs,TAR_MA_coefs,         &
       AR_lags,MA_lags,thr_resp_ind,thr_lag,thresholds,TAR_covs)
!***********************************************************************
!  FORTRAN 90 subroutine to get parameters for generating realizations
!  from a multivariate threshold AR process.
!***********************************************************************
!   USE define_types
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_k, max_p, max_q, max_no_regimes 
    INTEGER, INTENT(in) :: file_label, k
    INTEGER, INTENT(out) :: p, q, no_regimes, thr_resp_ind, thr_lag
    INTEGER, INTENT(out), DIMENSION(max_p) :: AR_lags
    INTEGER, INTENT(out), DIMENSION(max_q) :: MA_lags
    REAL, INTENT(out), DIMENSION(max_no_regimes) :: thresholds
    REAL, INTENT(out), DIMENSION(max_no_regimes, max_k, max_k) :: TAR_covs
    REAL, INTENT(out), DIMENSION(max_no_regimes, max_p, max_k, max_k) :: TAR_AR_coefs
    REAL, INTENT(out), DIMENSION(max_no_regimes, max_q, max_k, max_k) :: TAR_MA_coefs
!
    INTEGER :: reg_ct, dim1, dim2, info, j
    REAL, DIMENSION(k, k) :: cov
!
    WRITE(file_label,400) k
    WRITE(*,*) "How many regimes in the TAR model?"
    READ(*,*) no_regimes
    WRITE(file_label,500) no_regimes
    WRITE(file_label,*)
!
    WRITE(*,*) "Enter the AR order (p) and MA order (q)."
    WRITE(*,*) "p = ?"
    READ(*,*) p
    WRITE(*,*) "q = ?"
    READ(*,*) q
    WRITE(file_label,510) p, q
    WRITE(file_label,*)
!
    DO reg_ct = 1, no_regimes
       WRITE(*,520) reg_ct
       WRITE(file_label,520) reg_ct
       DO dim1 = 1,k
          READ(*,*) (cov(dim1,dim2), dim2 = 1, k)
          WRITE(file_label,*) (cov(dim1,dim2), dim2 = 1, k)
       END DO
       TAR_covs(reg_ct,1:k,1:k) = cov(1:k,1:k)
       WRITE(file_label,*)
    END DO
!
    IF(p > 0) THEN
       WRITE(*,*) "What are the AR lags?"
       READ(*,*) (AR_lags(j), j = 1, p)
       WRITE(file_label,525,ADVANCE="NO") 
       WRITE(file_label,*) (AR_lags(j), j = 1, p)
       DO reg_ct = 1, no_regimes
          WRITE(*,530) reg_ct
          WRITE(file_label,540) reg_ct
          DO j = 1, p
             WRITE(*,550) j
             DO dim1 = 1,k
                READ(*,*) (TAR_AR_coefs(reg_ct,j,dim1,dim2), dim2 = 1, k)
                WRITE(file_label,*) (TAR_AR_coefs(reg_ct,j,dim1,dim2), dim2 = 1, k)
             END DO
          END DO
       END DO
    END IF
!
    IF(q > 0) THEN
       WRITE(*,*) "What are the MA lags?"
       READ(*,*) (MA_lags(j), j = 1, q)
       WRITE(file_label,*)
       WRITE(file_label,555,ADVANCE="NO") 
       WRITE(file_label,*) (MA_lags(j), j = 1, q)
       DO reg_ct = 1, no_regimes
          WRITE(*,560) reg_ct
          WRITE(file_label,570) reg_ct
          DO j = 1, q
             WRITE(*,580) j
             DO dim1 = 1, k
                READ(*,*) (TAR_MA_coefs(reg_ct,j,dim1,dim2), dim2 = 1, k)
                WRITE(file_label,*) (TAR_MA_coefs(reg_ct,j,dim1,dim2), dim2 = 1, k)
             END DO
          END DO
       END DO
    END IF
!
    WRITE(*,590) 
    WRITE(*,*) "Threshold response index?"
    READ(*,*) thr_resp_ind
    WRITE(*,*) "Threshold lag?"
    READ(*,*) thr_lag
    WRITE(file_label,*)
    WRITE(file_label,600) thr_lag, thr_resp_ind
    !
    thresholds(1) = -9.0e15
    thresholds(no_regimes+1) = 9.0e10
    IF(no_regimes > 1) THEN
       WRITE(*,610) no_regimes-1
       READ(*,*) (thresholds(reg_ct+1), reg_ct = 1, no_regimes-1)
       WRITE(file_label,620,ADVANCE="NO")
       WRITE(file_label,*) (thresholds(reg_ct+1), reg_ct = 1, no_regimes-1)
    END IF
!
400 FORMAT("Vector threshold autoregressive moving average model of dimension ",I1,".")
500 FORMAT("The number of regimes in the TAR model is ",I2,".")
510 FORMAT("AR order (p) = ",I2,": MA order (q) = ",I2,".")
520 FORMAT("Covariance matrix of errors (row by row) for regime ",I2,".")
525 FORMAT("AR lags:")
530 FORMAT("Enter the AR matrix of coefficients for regime ",I2,".")
540 FORMAT("The AR matrix of coefficients for regime ",I2,":")
550 FORMAT("Enter the lag ",I2," AR matrix of coefficients, row by row.")
555 FORMAT("MA lags:")
560 FORMAT("Enter the MA matrix of coefficients for regime ",I2,".")
570 FORMAT("The MA matrix of coefficients for regime ",I2,":")
580 FORMAT("Enter the lag ",I2," MA matrix of coefficients, row by row.")
590 FORMAT("Enter the threshold response index and lag in that order.")
600 FORMAT("The threshold variable is X(t -",I2,",",I2,").")
610 FORMAT("Input ",I2," thesholds.")
620 FORMAT("The thresholds are: ")
!
    RETURN
  END SUBROUTINE get_mvTAR_params
!***********************************************************************
!  Generate realization:
!***********************************************************************
  SUBROUTINE gen_mvTAR(max_n,max_k,max_p,max_q,max_no_regimes,          &
       n,k,p,q,no_regimes,TAR_AR_coefs,TAR_MA_coefs,AR_lags,MA_lags,    &
       thr_resp_ind,thr_lag,thresholds,TAR_covs,cov_fac_option,extra,x)
!   USE define_types
!   USE stat_utilities
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_n, max_k, max_p, max_q, max_no_regimes
    INTEGER, INTENT(in) :: n, k, p, q, cov_fac_option, extra
    INTEGER, INTENT(in) :: no_regimes, thr_resp_ind, thr_lag
    INTEGER, INTENT(in), DIMENSION(p) :: AR_lags
    INTEGER, INTENT(in), DIMENSION(q) :: MA_lags
    REAL, INTENT(in), DIMENSION(max_no_regimes) :: thresholds
    REAL, INTENT(in), DIMENSION(max_no_regimes, max_p, max_k, k) :: TAR_AR_coefs
    REAL, INTENT(in), DIMENSION(max_no_regimes, max_q, max_k, k) :: TAR_MA_coefs
    REAL, INTENT(in), DIMENSION(max_no_regimes, max_k, k) :: TAR_covs
    REAL, INTENT(out), DIMENSION (max_n, k) :: x
!
    INTEGER :: regime_no, regime, t, j, nn
    REAL :: crit, thr1, thr2
    REAL, DIMENSION(max_n, k) :: eps
    REAL, DIMENSION(k) :: work_space
    REAL, DIMENSION(max_k, k) :: cov
    REAL, DIMENSION(no_regimes+2,2*n,k) :: all_eps
!
    nn = n + extra
    work_space = 0.0
    DO regime_no = 1, no_regimes
       cov(1:k,1:k) = TAR_covs(regime_no,1:k,1:k)
       CALL gen_mvnormal_r(max_n,max_k,nn,k,work_space,cov,cov_fac_option,eps)
       all_eps(regime_no,1:nn,1:k) = eps(1:nn,1:k)
    END DO
!
    work_space = 0.0
    x = 0.0
    DO t = thr_lag+1, nn
       crit = x(t-thr_lag, thr_resp_ind)
       regime = 1
       DO regime_no = 1, no_regimes
          thr1 = thresholds(regime_no)
          thr2 = thresholds(regime_no+1)
          IF(crit .GE. thr1 .AND. crit .LT. thr2) THEN
             regime = regime_no 
             GO TO 10
          END IF
       END DO
10     CONTINUE
!
       x(t,1:k) = all_eps(regime,t,1:k)
       DO j = 1, MIN(t-1, p)
          work_space = MATMUL(x(t-AR_lags(j),1:k),TAR_AR_coefs(regime,j,1:k,1:k))
          x(t,1:k) = x(t,1:k) + work_space
       END DO
       DO j = 1, MIN(t-1, q)
          work_space = MATMUL(all_eps(regime,t-MA_lags(j),1:k),TAR_MA_coefs(regime,j,1:k,1:k))
          x(t,1:k) = x(t,1:k) + work_space
       END DO
    END DO
!
    x(1:n,1:k) = x((extra+1):nn,1:k)
    RETURN
!
  END SUBROUTINE gen_mvTAR
!***********************************************************************
!  Generate vector threshold STAR:
!***********************************************************************
!  Get coefficients:
!***********************************************************************
  SUBROUTINE get_mvSTAR_params(max_k,max_p,max_no_regimes,file_label, &
       k,p,sm_FUNCTION,sm_const,sm_param,STAR_AR_coefs,AR_lags,       &
       thr_resp_ind,thr_lag)
!***********************************************************************
!  FORTRAN 90 subroutine to get parameters for generating realizations
!  from a multivariate smoothed threshold ARMA process.
!***********************************************************************
!    USE define_types
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_k, max_p, max_no_regimes
    INTEGER, INTENT(in) :: file_label, k
    INTEGER, INTENT(out) :: p, sm_FUNCTION, thr_resp_ind, thr_lag
    INTEGER, INTENT(out), DIMENSION(max_p) :: AR_lags
    REAL, INTENT(out) :: sm_param, sm_const
    REAL, INTENT(out), DIMENSION(max_no_regimes, max_p, max_k, max_k) :: STAR_AR_coefs
!
    INTEGER :: reg_ct, dim1, dim2, info, j
    REAL, DIMENSION(k,k) :: cov
!
    WRITE(file_label,300) k
!
    WRITE(*,*) "What function should be used for smoothing?"
    WRITE(*,*) "  (1 = logistic, 2 = exponential, 3 = quadratic log)"
    READ(*,*) sm_FUNCTION
    WRITE(*,*) "What is the value for the smoothing function constant term?"
    READ(*,*) sm_const
    WRITE(*,*) "What is the value for the smoothing function parameter?"
    READ(*,*) sm_param
    IF(sm_FUNCTION == 1) THEN
       WRITE(file_label,400)
    ELSE IF(sm_FUNCTION == 2) THEN
       WRITE(file_label,410)
    ELSE IF(sm_FUNCTION == 3) THEN
       WRITE(file_label,420)
    END IF
    WRITE(file_label,430) sm_const
    WRITE(file_label,440) sm_param
    WRITE(file_label,*)
!
    WRITE(*,*) "Enter the AR order."
    WRITE(*,*) "p = ?"
    READ(*,*) p
    WRITE(file_label,510) p
    WRITE(file_label,*)
!
    IF(p > 0) THEN
       WRITE(*,*) "What are the AR lags?"
       READ(*,*) (AR_lags(j), j = 1, p)
       WRITE(file_label,525,ADVANCE="NO") 
       WRITE(file_label,*) (AR_lags(j), j = 1, p)
       DO reg_ct = 1, 2
          WRITE(*,530) reg_ct
          WRITE(file_label,540) reg_ct
          DO j = 1, p
             WRITE(*,550) j
             DO dim1 = 1,k
                READ(*,*) (STAR_AR_coefs(reg_ct,j,dim1,dim2), dim2 = 1, k)
                WRITE(file_label,*) (STAR_AR_coefs(reg_ct,j,dim1,dim2), dim2 = 1, k)
             END DO
          END DO
       END DO
    END IF
!
    WRITE(*,590) 
    WRITE(*,*) "Threshold response index?"
    READ(*,*) thr_resp_ind
    WRITE(*,*) "Threshold lag?"
    READ(*,*) thr_lag
    WRITE(file_label,*)
    WRITE(file_label,600) thr_lag, thr_resp_ind
!
300 FORMAT("Smoothed threshold autoregressive process of dimension ",I1,".")
!
400 FORMAT("The function used for smoothing was the logistic function.")
410 FORMAT("The function used for smoothing was the exponential function.")
420 FORMAT("The function used for smoothing was the quadratic log function.")
430 FORMAT("The smoothing function constant term is ",F8.4,".")
440 FORMAT("The smoothing function parameter is",F8.4,".")
!
510 FORMAT("AR order (p) = ",I2,".")
525 FORMAT("AR lags:")
530 FORMAT("Enter the AR matrix of coefficients for regime ",I2,".")
540 FORMAT("The AR matrix of coefficients for regime ",I2,":")
550 FORMAT("Enter the lag ",I2," AR matrix of coefficients, row by row.")
590 FORMAT("Enter the threshold response index and lag in that order.")
600 FORMAT("The threshold variable is X(t -",I2,",",I2,").")
!
    RETURN
  END SUBROUTINE get_mvSTAR_params
!***********************************************************************
!  Generate realization:
!***********************************************************************
  SUBROUTINE gen_mvSTAR(max_n,max_k,max_p,max_no_regimes,n,k,p,         &
       sm_function,sm_const,sm_param,STAR_AR_coefs,AR_lags,             &
       thr_resp_ind,thr_lag,cov,cov_fac_option,extra,x)
!    USE define_types
!    USE stat_utilities
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_n, max_k, max_p, max_no_regimes
    INTEGER, INTENT(in) :: n, k, p, cov_fac_option, extra
    INTEGER, INTENT(in) :: sm_FUNCTION, thr_resp_ind, thr_lag
    INTEGER, INTENT(in), DIMENSION(p) :: AR_lags
    REAL, INTENT(in) :: sm_const, sm_param
    REAL, INTENT(in), DIMENSION(max_no_regimes, max_p, max_k, k) :: STAR_AR_coefs
    REAL, INTENT(in), DIMENSION(max_k, k) :: cov
    REAL, INTENT(out), DIMENSION (max_n, k) :: x
!
    INTEGER :: nn, regime_no, regime, t, j
    REAL :: s
    REAL, DIMENSION(max_n, k) :: eps
    REAL, DIMENSION(k) :: work_space1, work_space2
!
    nn = n + extra
    work_space1 = 0.0
    eps = 0.0
    CALL gen_mvnormal_r(max_n,max_k,nn,k,work_space1,cov,cov_fac_option,eps)
!
    x(1:nn,1:k) = eps(1:nn,1:k)
    DO t = thr_lag+1, nn
       work_space1 = 0.0
       work_space2 = 0.0
!
       DO j = 1, MIN(t-1, p)
          work_space1 = MATMUL(x(t-AR_lags(j),1:k),STAR_AR_coefs(1,j,1:k,1:k))
       END DO
       DO j = 1, MIN(t-1, p)
          work_space2 = MATMUL(x(t-AR_lags(j),1:k),STAR_AR_coefs(2,j,1:k,1:k))
       END DO
!
       s = 0.0
       IF(sm_FUNCTION == 1) THEN
!!          s = logistic_sm(x(t-thr_lag,thr_resp_ind),sm_const,sm_param)
       ELSE IF(sm_FUNCTION == 2) THEN
!!          s = exponential_sm(x(t-thr_lag,thr_resp_ind),sm_const,sm_param)
       ELSE IF(sm_FUNCTION == 3) THEN
!!          s = quad_log_sm(x(t-thr_lag,thr_resp_ind),sm_const,sm_param)
       END IF
!
       x(t,1:k) = work_space1*(1.0 - s) + work_space2*s + eps(t,1:k)
    END DO
!
    x(1:n,1:k) = x((extra+1):nn,1:k)
!
    RETURN
  END SUBROUTINE gen_mvSTAR
!***********************************************************************
!  Generate vector exponential AR:
!***********************************************************************
!  Get coefficients:
!***********************************************************************
  SUBROUTINE get_mvEXPAR_params(max_k,max_p,file_label,k,p,AR_cons,      &
       AR_coefs,expar_coefs,d)
!***********************************************************************
!  FORTRAN90 subroutine to get parameters for multivariate exponential
!  autoregressive process.
!***********************************************************************
!    USE define_types
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_k, max_p, file_label, k
    INTEGER, INTENT(out) :: p, d
    REAL, INTENT(out), DIMENSION(max_p, max_k, max_k) :: AR_cons, AR_coefs
    REAL, INTENT(out), DIMENSION(max_p, max_k*max_k, max_k) :: expar_coefs
!
    INTEGER :: ts_lag, dim1, dim2, i
!
    WRITE(file_label,400) k
    WRITE(*,*) "Enter the AR order (p)."
    READ(*,*) p
    WRITE(file_label,500) p
    WRITE(file_label,*)
!
    IF(p > 0) THEN
       WRITE(*,*) "Enter the AR intercept terms (row by row)."
       WRITE(file_label,510)
       DO ts_lag = 1, p
          WRITE(*,520) ts_lag
          WRITE(file_label,520) ts_lag
          DO dim1 = 1, k
             READ(*,*) (AR_cons(ts_lag,dim1,dim2), dim2 = 1, k)
             WRITE(file_label,*) (AR_cons(ts_lag,dim1,dim2), dim2 = 1, k)
          END DO
       END DO
!
       WRITE(*,*) "Enter the AR coefficients (row by row)."
       WRITE(file_label,*)
       WRITE(file_label,530)
       DO ts_lag = 1, p
          WRITE(*,520) ts_lag
          WRITE(file_label,520) ts_lag
          DO dim1 = 1, k
             READ(*,*) (AR_coefs(ts_lag,dim1,dim2), dim2 = 1, k)
             WRITE(file_label,*) (AR_coefs(ts_lag,dim1,dim2), dim2 = 1, k)
          END DO
       END DO
!
       WRITE(*,*) "Enter the delay for the exponential term."
       READ(*,*) d
       WRITE(file_label,550) d

       WRITE(*,*) "Enter the exponential parameters (row by row)."
       WRITE(file_label,*)
       WRITE(file_label,540)
       DO ts_lag = 1, p
          WRITE(*,520) ts_lag
          WRITE(file_label,520) ts_lag
          DO dim1 = 1, k
             WRITE(*,525) dim1
             WRITE(file_label,525) dim1
             READ(*,*) (expar_coefs(ts_lag,dim2,dim1), dim2 = 1, k*k)
             WRITE(file_label,*) (expar_coefs(ts_lag,dim2,dim1), dim2 = 1, k*k)
          END DO
       END DO
!
    END IF
!
400 FORMAT("Vector exponential autoregressive process of dimension ",I1,".")
500 FORMAT("The AR order (p) is ",I2,".")
510 FORMAT("The AR constant terms (row by row):")
520 FORMAT("Lag ",I2,":")
525 FORMAT("Time series component ",I1,":")
530 FORMAT("The AR coefficients (row by row) are:")
540 FORMAT("The exponential parameters (row by row) are:")
550 FORMAT("Delay for the exponential variable: ",I1,".")
!
    RETURN
  END SUBROUTINE get_mvEXPAR_params
!***********************************************************************
!  Generate realization:
!***********************************************************************
  SUBROUTINE gen_mvEXPAR(max_n,max_k,max_p,n,k,p,AR_cons,AR_coefs,      &
       expar_coefs,d,cov,cov_fac_option,extra,x)
!    USE define_types
!    USE stat_utilities
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, max_k, max_p, n, k, p, d
    INTEGER, INTENT(in) :: cov_fac_option, extra
    REAL, INTENT(in), DIMENSION(max_k, k) :: cov
    REAL, INTENT(in), DIMENSION(max_p, max_k, k) :: AR_cons, AR_coefs
    REAL, INTENT(in), DIMENSION(max_p, max_k*max_k, k) :: expar_coefs
    REAL, INTENT(out), DIMENSION(max_n, k) :: x
!
    INTEGER :: nn, s, t, j, dim1, dim2, i, ii
    REAL, DIMENSION(max_n, k) :: eps
    REAL, DIMENSION(k) :: work_space, temp
    REAL, DIMENSION(k, k) :: cc
    REAL, DIMENSION(p*k, k) :: eterm
    REAL, DIMENSION(p, k, k) :: coefs
!
    nn = n + extra
    work_space = 0.0
    eterm = 0.0
    temp = 0.0
    eps = 0.0
    s = max(p,d)
    CALL gen_mvnormal_r(max_n,max_k,nn,k,work_space,cov,cov_fac_option,eps)
!
    x(1:nn,1:k) = eps(1:nn,1:k)
    DO t = s+1, nn
       coefs = 0.0
       temp(1:k) = x(t-d,1:k)*x(t-d,1:k)
       DO j = 1, p	   
          DO dim1 = 1, k	   
             DO dim2 = 1, k
                i = k*(dim2-1) + 1
                ii = dim2*k
                work_space(1:k) = expar_coefs(j,i:ii,dim1)
                eterm(dim1,dim2) = DOT_PRODUCT(temp,work_space)
             END DO
          END DO
          coefs(j,1:k,1:k) = AR_coefs(j,1:k,1:k)*EXP(eterm(1:k,1:k))
          coefs(j,1:k,1:k) = coefs(j,1:k,1:k) + AR_cons(j,1:k,1:k)
!
          cc(1:k,1:k) = coefs(j,1:k,1:k)
          cc = TRANSPOSE(cc)
!
          work_space(1:k) = MATMUL(x(t-j,1:k),cc)
          x(t,1:k) = x(t,1:k) + work_space(1:k)
       END DO
    END DO
!  
    x(1:n,1:k) = x((extra+1):nn,1:k)
!
    RETURN
  END SUBROUTINE gen_mvEXPAR
!
! END MODULE nlts_utilities

MODULE nlts_interfaces
!***********************************************************************
!  FORTRAN 90 module containing interfaces for non-linear time series
!  analysis programs.
!***********************************************************************
  INTERFACE
     SUBROUTINE get_mvbilinear_params(max_k,max_p,max_q,file_label,k,p,q,&
		  cp_option,AR_coefs,MA_coefs,cp_dim,cp_coefs)
!       USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_k, max_p, max_q, file_label, k
       INTEGER, INTENT(out) :: p, q, cp_option, cp_dim
       REAL, INTENT(out), DIMENSION(max_k, (max_p*max_k)**2) :: cp_coefs
       REAL, INTENT(out), DIMENSION(max_p, max_k, k) :: AR_coefs
       REAL, INTENT(out), DIMENSION(max_q, max_k, k) :: MA_coefs
     END SUBROUTINE get_mvbilinear_params
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_mvbilinear(max_n,max_k,max_p,max_q,n,k,p,q,AR_coefs, &
          MA_coefs,cp_option,cp_dim,cp_coefs,cov_fac_option,cov,extra,x)
 !      USE define_types
 !      USE f90_utilities, ONLY : vech
 !      USE stat_utilities
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, max_k, max_p, max_q
       INTEGER, INTENT(in) :: n, k, p, q, cp_option, cp_dim
       INTEGER, INTENT(in) :: cov_fac_option, extra
       REAL, INTENT(in), DIMENSION(max_k, k) :: cov
       REAL, INTENT(in), DIMENSION(max_k, cp_dim) :: cp_coefs
       REAL, INTENT(in), DIMENSION(max_p, max_k, k) :: AR_coefs
       REAL, INTENT(in), DIMENSION(max_q, max_k, k) :: MA_coefs
       REAL, INTENT(inout), DIMENSION(max_n, k) :: x
     END SUBROUTINE gen_mvbilinear
  END INTERFACE
!
  INTERFACE
     SUBROUTINE get_mvTAR_params(max_k,max_p,max_q,max_no_regimes,         &
	      file_label,k,p,q,no_regimes,TAR_AR_coefs,TAR_MA_coefs,           &
          AR_lags,MA_lags,thr_resp_ind,thr_lag,thresholds,TAR_covs)
!       USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_k, max_p, max_q, max_no_regimes
       INTEGER, INTENT(in) :: file_label, k
       INTEGER, INTENT(out) :: p, q, no_regimes, thr_resp_ind, thr_lag
       INTEGER, INTENT(out), DIMENSION(max_p) :: AR_lags
       INTEGER, INTENT(out), DIMENSION(max_q) :: MA_lags
       REAL, INTENT(out), DIMENSION(max_no_regimes) :: thresholds
       REAL, INTENT(out), DIMENSION(max_no_regimes, max_k, max_k) :: TAR_covs
       REAL, INTENT(out), DIMENSION(max_no_regimes, max_p, max_k, max_k) :: TAR_AR_coefs
	   REAL, INTENT(out), DIMENSION(max_no_regimes, max_q, max_k, max_k) :: TAR_MA_coefs
     END SUBROUTINE get_mvTAR_params
  END INTERFACE
!
!!INTERFACE
!!   SUBROUTINE gen_mvTAR(max_n,max_k,max_p,max_q,max_no_regimes,          &
!!        n,k,p,q,no_regimes,TAR_AR_coefs,TAR_MA_coefs,AR_lags,MA_lags,    &
!!        thr_resp_ind,thr_lag,thresholds,TAR_covs,cov_fac_option,extra,x)
!       USE define_types
!       USE stat_utilities
!!     IMPLICIT NONE
!!     INTEGER, INTENT(in) :: max_n, max_k, max_p, max_q, max_no_regimes
!!     INTEGER, INTENT(in) :: n, k, p, q, cov_fac_option, extra
!!     INTEGER, INTENT(in) :: no_regimes, thr_resp_ind, thr_lag
!!     INTEGER, INTENT(in), DIMENSION(p) :: AR_lags
!!     INTEGER, INTENT(in), DIMENSION(q) :: MA_lags
!!     REAL, INTENT(in), DIMENSION(max_no_regimes) :: thresholds
!!     REAL, INTENT(in), DIMENSION(no_regimes, max_k, k) :: TAR_covs
!!     REAL, INTENT(in), DIMENSION(no_regimes, max_p, max_k, k) :: TAR_AR_coefs
!!     REAL, INTENT(in), DIMENSION(no_regimes, max_q, max_k, k) :: TAR_MA_coefs
!!     REAL, INTENT(out), DIMENSION(max_n, k) :: x
!!   END SUBROUTINE gen_mvTAR
!!END INTERFACE
!
  INTERFACE
     SUBROUTINE get_mvSTAR_params(max_k,max_p,max_no_regimes,file_label,    &
          k,p,sm_func,sm_const,sm_param,STAR_AR_coefs,AR_lags,thr_resp_ind, &
          thr_lag)
!       USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_k, max_p, max_no_regimes
       INTEGER, INTENT(in) :: file_label, k
       INTEGER, INTENT(out) :: p, sm_func, thr_resp_ind, thr_lag
       INTEGER, INTENT(out), DIMENSION(max_p) :: AR_lags
       REAL,  INTENT(out) :: sm_param, sm_const
       REAL,  INTENT(out), DIMENSION(max_no_regimes, max_p, max_k, max_k) :: STAR_AR_coefs
     END SUBROUTINE get_mvSTAR_params
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_mvSTAR(max_n,max_k,max_p,max_no_regimes,n,k,p,sm_func,   &
          sm_const,sm_param,STAR_AR_coefs,AR_lags,thr_resp_ind,thr_lag,      &
          cov,cov_fac_option,extra,x)
!       USE define_types
!       USE stat_utilities
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_n, max_k, max_p, max_no_regimes
       INTEGER, INTENT(in) :: n, k, p, extra, cov_fac_option
       INTEGER, INTENT(in) :: sm_func, thr_resp_ind, thr_lag
       INTEGER, INTENT(in), DIMENSION(p) :: AR_lags
       REAL, INTENT(in) :: sm_param, sm_const
       REAL, INTENT(in), DIMENSION(max_k, k) :: cov
       REAL, INTENT(in), DIMENSION(max_no_regimes, max_p, max_k, k) :: STAR_AR_coefs
       REAL, INTENT(out), DIMENSION(max_n, k) :: x
     END SUBROUTINE gen_mvSTAR
  END INTERFACE
!
  INTERFACE
     SUBROUTINE get_mvEXPAR_params(max_k,max_p,file_label,k,p,AR_cons,   &
          AR_coefs,expar_coefs,d)
!       USE define_types
!       USE stat_utilities
       IMPLICIT NONE
       INTEGER, INTENT(in) :: max_k, max_p, file_label, k
       INTEGER, INTENT(out) :: p, d
       REAL, INTENT(out), DIMENSION(max_p, max_k, max_k) :: AR_cons, AR_coefs
       REAL, INTENT(out), DIMENSION(max_p, max_k*max_k, max_k) :: expar_coefs
         END SUBROUTINE get_mvEXPAR_params
  END INTERFACE
!
  INTERFACE
    SUBROUTINE gen_mvEXPAR(max_n,max_k,max_p,n,k,p,AR_cons,AR_coefs,    &
         expar_coefs,d,cov,cov_fac_option,extra,x)
!      USE define_types
!      USE stat_utilities
      IMPLICIT NONE
      INTEGER, INTENT(in) :: max_n, max_k, max_p, n, k, p, d
      INTEGER, INTENT(in) :: cov_fac_option, extra
      REAL, INTENT(in), DIMENSION(max_k, k) :: cov
      REAL, INTENT(in), DIMENSION(max_p, max_k, k) :: AR_cons, AR_coefs
      REAL, INTENT(in), DIMENSION(max_p, max_k*max_k, max_k) :: expar_coefs
      REAL, INTENT(out), DIMENSION(max_n, k) :: x
    END SUBROUTINE gen_mvEXPAR
  END INTERFACE
!
END MODULE nlts_interfaces


MODULE f90_utilities
!**********************************************************************
!   FORTRAN 90 module for defining necessary utilities for various
!   mathematical computations.
!
!   Created: 10/28/2002 JLH
!
!   Notes:  Some subroutines require BLAS subroutines xGEMV, xGEMM,
!           or BLAS function xdot.  All are available for free download
!           from http://www.netlib.org/blas/ .
!           Some subroutines require LAPACK subroutines xGETRF and
!           xGETRI.  Both are available for free download from
!           http://www.netlib.org/lapack/ .
!           In notation above, the lower-case "x" preceding the
!           subroutine or function name is replaced by an "S" for
!           single precision calls or a "D" for double precision
!           calls.
!
!   Contents:  
!         Routines that move data:
!                       swap
!         Argument checking and error handling: 
!			assert_eq, error
!         Routines for matrix opertaions:
!                       mat_mult, vech, cholesky_fac
!
!**********************************************************************
!  USE define_types
  IMPLICIT NONE
!**********************************************************************
!   Routines for moving data:
!**********************************************************************
  INTERFACE swap
     MODULE PROCEDURE swap_i, swap_r, swap_rv, swap_d, swap_dv,       &
          swap_c, swap_cv, swap_cm, swap_z, swap_zv, swap_zm,         &
          masked_swap_rs, masked_swap_rv, masked_swap_rm,             &
          masked_swap_rd, masked_swap_dv, masked_swap_dm               
  END INTERFACE swap
!***********************************************************************
!   Routines for multiplying matrices:
!***********************************************************************
  INTERFACE mat_mult
     MODULE PROCEDURE mat_mult_s, mat_mult_d, vv_mult_s, vv_mult_d,   &
          vm_mult_s, vm_mult_d, mv_mult_s  ! , mv_mult_d
  END INTERFACE mat_mult
!***********************************************************************
!  Routines for computing the half-stacking vector:
!***********************************************************************
!!!  INTERFACE vech
!!!     MODULE PROCEDURE vech_r ! , vech_d
!!!  END INTERFACE vech
!***********************************************************************
!  Routines for computing the Cholesky decomposition:
!***********************************************************************
  INTERFACE cholesky_fac
     MODULE PROCEDURE cholesky_fac_r  ! , cholesky_fac_d
  END INTERFACE cholesky_fac
!**********************************************************************
!  Routines for argument checking and error handling (error is not
!  currently overloaded.
!**********************************************************************
  INTERFACE assert_eq
     MODULE PROCEDURE assert_eq2, assert_eq3, assert_eq4, assert_eqn
  END INTERFACE assert_eq
!***********************************************************************
!  Routines for sorting arrays and carrying indices.
!***********************************************************************
  INTERFACE index_sort
     MODULE PROCEDURE i_sort, r_sort  ! , d_sort
  END INTERFACE index_sort
CONTAINS
!**********************************************************************
!   Swap the contents of a and b.
!**********************************************************************
  SUBROUTINE swap_i(a,b)
!    USE define_types
    IMPLICIT NONE
    INTEGER, INTENT(inout) :: a, b
    INTEGER :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_i
!
  SUBROUTINE swap_r(a,b)
!    USE define_types
    IMPLICIT NONE
    REAL, INTENT(inout) :: a, b
    REAL :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_r
!
  SUBROUTINE swap_rv(a,b)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(inout) :: a, b
    REAL, DIMENSION(SIZE(a)) :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_rv
!
  SUBROUTINE swap_d(a,b)
!    USE define_types
    IMPLICIT NONE
    REAL, INTENT(inout) :: a, b
    REAL :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_d
!
  SUBROUTINE swap_dv(a,b)
 !   USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(inout) :: a, b
    REAL, DIMENSION(SIZE(a)) :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_dv
!
  SUBROUTINE swap_c(a,b)
!    USE define_types
    IMPLICIT NONE
    COMPLEX, INTENT(inout) :: a, b
    COMPLEX :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_c
!
  SUBROUTINE swap_cv(a,b)
!    USE define_types
    IMPLICIT NONE
    COMPLEX, DIMENSION(:), INTENT(inout) :: a, b
    COMPLEX, DIMENSION(SIZE(a)) :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_cv
!
  SUBROUTINE swap_cm(a,b)
!    USE define_types
    IMPLICIT NONE
    COMPLEX, DIMENSION(:,:), INTENT(inout) :: a, b
    COMPLEX, DIMENSION(SIZE(a,1), SIZE(a,2)) :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_cm
!
  SUBROUTINE swap_z(a,b)
!    USE define_types
    IMPLICIT NONE
    COMPLEX, INTENT(inout) :: a, b
    COMPLEX :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_z
!
  SUBROUTINE swap_zv(a,b)
!    USE define_types
    IMPLICIT NONE
    COMPLEX, DIMENSION(:), INTENT(inout) :: a, b
    COMPLEX, DIMENSION(SIZE(a)) :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_zv
!
  SUBROUTINE swap_zm(a,b)
!    USE define_types
    IMPLICIT NONE
    COMPLEX, DIMENSION(:,:), INTENT(inout) :: a, b
    COMPLEX, DIMENSION(SIZE(a,1), SIZE(a,2)) :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_zm
!
  SUBROUTINE masked_swap_rs(a,b,mask)
!    USE define_types
    IMPLICIT NONE
    REAL, INTENT(inout) :: a, b
    LOGICAL, INTENT(in) :: mask
    REAL :: swp
    IF(mask) THEN
       swp = a
       a = b
       b = swp
    END IF
    RETURN
  END SUBROUTINE masked_swap_rs
!
  SUBROUTINE masked_swap_rv(a,b,mask)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(inout) :: a, b
    LOGICAL, DIMENSION(:), INTENT(in) :: mask
    REAL, DIMENSION(SIZE(a)) :: swp
    WHERE(mask)
       swp = a
       a = b
       b = swp
    END WHERE
    RETURN
  END SUBROUTINE masked_swap_rv
!
  SUBROUTINE masked_swap_rm(a,b,mask)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(inout) :: a, b
    LOGICAL, DIMENSION(:,:), INTENT(in) :: mask
    REAL, DIMENSION(SIZE(a,1),SIZE(a,2)) :: swp
    WHERE(mask)
       swp = a
       a = b
       b = swp
    END WHERE
    RETURN
  END SUBROUTINE masked_swap_rm
!
  SUBROUTINE masked_swap_rd(a,b,mask)
!    USE define_types
    IMPLICIT NONE
    REAL, INTENT(inout) :: a, b
    LOGICAL, INTENT(in) :: mask
    REAL :: swp
    IF(mask) THEN
       swp = a
       a = b
       b = swp
    END IF
    RETURN
  END SUBROUTINE masked_swap_rd
!
  SUBROUTINE masked_swap_dv(a,b,mask)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(inout) :: a, b
    LOGICAL, DIMENSION(:), INTENT(in) :: mask
    REAL, DIMENSION(SIZE(a)) :: swp
    WHERE(mask)
       swp = a
       a = b
       b = swp
    END WHERE
    RETURN
  END SUBROUTINE masked_swap_dv
!
  SUBROUTINE masked_swap_dm(a,b,mask)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(inout) :: a, b
    LOGICAL, DIMENSION(:,:), INTENT(in) :: mask
    REAL, DIMENSION(SIZE(a,1),SIZE(a,2)) ::swp
    WHERE(mask)
       swp = a
       a = b
       b = swp
    END WHERE
    RETURN
  END SUBROUTINE masked_swap_dm
!***********************************************************************
!   Matrix multiplication routines:
!***********************************************************************
  SUBROUTINE mat_mult_s(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(in) :: a, b
    REAL, DIMENSION(:,:), INTENT(out) :: c
!
    INTEGER :: n, m, k, info
!
    EXTERNAL sgemm
!
    n = SIZE(a,1)
    m = SIZE(a,2)
    k = SIZE(b,2)
!
    info = assert_eq(SIZE(b,1), m,                                     &
         "Matrix dimensions not correct for multiplication")
!
    CALL sgemm("N","N",n,k,m,1.0,a,n,b,m,1.0,c,n)
!
    RETURN
  END SUBROUTINE mat_mult_s
!
  SUBROUTINE mat_mult_d(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(in) :: a, b
    REAL, DIMENSION(:,:), INTENT(out) :: c
!
    INTEGER :: n, m, k, info
!
    EXTERNAL dgemm
!
    n = SIZE(a,1)
    m = SIZE(a,2)
    k = SIZE(b,2)
!
    info = assert_eq(SIZE(b,1),m,                                     &
         "Matrix dimensions not correct for multiplication.")
!
    CALL dgemm("N","N",n,k,m,1.0,a,n,b,m,1.0,c,n)
!
    RETURN
  END SUBROUTINE mat_mult_d
!
  SUBROUTINE vv_mult_s(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(in) :: a, b
    REAL, INTENT(out) :: c
    REAL :: sdot
!
    EXTERNAL sdot
!
    c = sdot(SIZE(a),a,1,b,1)
!
    RETURN
  END SUBROUTINE vv_mult_s
!
  SUBROUTINE vv_mult_d(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(in) :: a, b
    REAL, INTENT(out) :: c
    REAL :: ddot
!
    EXTERNAL ddot
!
    c = ddot(SIZE(a),a,1,b,1)
!
    RETURN
  END SUBROUTINE vv_mult_d
!
  SUBROUTINE vm_mult_s(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(in) :: a
    REAL, DIMENSION(:,:), INTENT(in) :: b
    REAL, DIMENSION(:,:), INTENT(out) :: c
!
    REAL, DIMENSION(SIZE(a),1) :: work
!
    INTEGER :: info, n, k
!
    EXTERNAL sgemm
!
    n = SIZE(a)
    k = SIZE(b,2)
    info = assert_eq(SIZE(b,1),1,"The matrix must be 1 x k.")
!
    work = RESHAPE(a,(/n, 1/))
!
    CALL sgemm("N","N",n,k,1,1.0,work,n,b,1,1.0,c,n)
!
    RETURN
  END SUBROUTINE vm_mult_s
!
  SUBROUTINE vm_mult_d(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(in) :: a
    REAL, DIMENSION(:,:), INTENT(in) :: b
    REAL, DIMENSION(:,:), INTENT(out) :: c
!
    INTEGER :: info, n, k
    REAL, DIMENSION(SIZE(a),1) :: work
!
    EXTERNAL dgemm
!
    n = SIZE(a)
    k = SIZE(b,2)
    info = assert_eq(SIZE(b,1),1,"The matrix must be 1 x k.")
!
    work = RESHAPE(a,(/n, 1/))
!
    CALL dgemm("N","N",n,k,1,1.0,work,n,b,1,1.0,c,n)
!
    RETURN
  END SUBROUTINE vm_mult_d
!
  SUBROUTINE mv_mult_s(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(in) :: a
    REAL, DIMENSION(:), INTENT(in) :: b
    REAL, DIMENSION(:), INTENT(out) :: c
!
    INTEGER :: info, n, m
!
    EXTERNAL sgemv
!
    n = SIZE(a,1)
    m = SIZE(a,2)
    info = assert_eq(m,SIZE(b),"The matrix must be 1 x m.")
!
    CALL sgemv("N",n,m,1.0,a,n,b,1,1.0,c,1)

    RETURN
  END SUBROUTINE mv_mult_s
!
  SUBROUTINE mv_mult_d(a,b,c)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(in) :: a
    REAL, DIMENSION(:), INTENT(in) :: b
    REAL, DIMENSION(:), INTENT(out) :: c
!
    INTEGER :: info, n, m
!
    EXTERNAL dgemv
!
    n = SIZE(a,1)
    m = SIZE(a,2)
    info = assert_eq(m,SIZE(b),"The matrix must be 1 x m.")
!
    CALL dgemv("N",n,m,1.0,a,n,b,1,1.0,c,1)
!
    RETURN
  END SUBROUTINE mv_mult_d
!***********************************************************************
!   Half-stacking vector subroutines:
!***********************************************************************
!***********************************************************************
!   FORTRAN subroutine to calculate the stacking or half-stacking
!   vector, v, of the product of two vectors, a and b.
!
!   Input: a = a double precision matrix of dimension n x m.
!          b = a double precision matrix of dimension m x k.
!          option = an integer indicating whether to take the half-
!                   stacking vector (iopt = 0) or the stacking vector
!                   (iopt = 1).
!          n = an integer containing the number of columns of a.
!          k = an integer containing the number of rows of b.
!
!   Output: v = a double precision vector containing the half-stacking
!               or stacking vector of a and b.  If iopt = 0, the 
!               length of y is (nk)[(nk)+1]/2.  If iopt = 1, the 
!               length of z is nk.
!***********************************************************************
  SUBROUTINE vech_r(a,b,n,ndim,m,mdim,k,option,v)
!    USE define_types
    IMPLICIT NONE
    INTEGER, INTENT(in) :: n, ndim, m, mdim, k, option
    REAL, DIMENSION(ndim), INTENT(in) :: a
    REAL, DIMENSION(1,mdim), INTENT(in) :: b
    REAL, DIMENSION(k**2), INTENT(inout) :: v
!  
    INTEGER :: lower_limit, vindex, i, j
!
    v = 0.0
!
    lower_limit = 1
    vindex = 0
!
    DO i = 1, k
       IF(option == 0) lower_limit = i
       DO j = lower_limit, n
          vindex = vindex + 1
          v(vindex) = a(j)*b(1,i)
       END DO
    END DO
    RETURN
  END SUBROUTINE vech_r
!
  SUBROUTINE vech_d(a,b,n,ndim,m,mdim,k,option,v)
!    USE define_types
    IMPLICIT NONE
    INTEGER, INTENT(in) :: n, ndim, m, mdim, k, option
    REAL, DIMENSION(ndim), INTENT(in) :: a
    REAL, DIMENSION(1,mdim), INTENT(in) :: b
    REAL, DIMENSION(k**2), INTENT(inout) :: v
!
    INTEGER :: lower_limit, vindex, i, j
!
    v = 0.0
    
    lower_limit = 1
    vindex = 0
!
    DO i = 1, k
       IF(option == 0) lower_limit = i
       DO j = lower_limit, n
          vindex = vindex + 1
          v(vindex) = a(j)*b(1,i)
       END DO
    END DO
    RETURN
  END SUBROUTINE vech_d
!***********************************************************************
!   Cholesky decomposition subroutines:
!***********************************************************************
!**********************************************************************
!   FORTRAN 90 subroutine for computing the Cholesky factorization of
!   an n x n positive definite matrix a.  The Cholesky factor is 
!   returned in the upper triangular matrix u.
!
!   Created: 10/28/2003 JLH
!**********************************************************************
  SUBROUTINE cholesky_fac_r(x,u)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(in) :: x
    REAL, DIMENSION(SIZE(x,1),SIZE(x,2)), INTENT(out) :: u
!
    INTEGER :: info, i, j
!
    EXTERNAL spotrf
!
    DO i = 2, SIZE(x,1)
    DO j = 1, i-1
       u(i,j) = 0.0
    END DO
    END DO
!
    CALL spotrf("U",SIZE(x,1),u,SIZE(x,1),info)
!
    RETURN
  END SUBROUTINE cholesky_fac_r
!
  SUBROUTINE cholesky_fac_d(x,u)
!    USE define_types
    IMPLICIT NONE
    REAL, DIMENSION(:,:), INTENT(in) :: x
    REAL, DIMENSION(SIZE(x,1),SIZE(x,2)), INTENT(out) :: u
!
    INTEGER :: info, i, j
!
    EXTERNAL dpotrf
!
    DO i = 2, SIZE(x,1)
    DO j = 1, i-1
       u(i,j) = 0.0
    END DO
    END DO
!
    CALL dpotrf("U",SIZE(x,1),u,SIZE(x,1),info)
!
    RETURN
  END SUBROUTINE cholesky_fac_d
!***********************************************************************
!   Error handling routines:
!**********************************************************************
!   Report and die if integers not all equal (used for size checking).
!**********************************************************************
  FUNCTION assert_eq2(n1,n2,string)
!    USE define_types
    IMPLICIT NONE
    CHARACTER(len=*), INTENT(in) :: string
    INTEGER, INTENT(in) :: n1, n2
    INTEGER :: assert_eq2
!
    IF(n1 == n2) THEN
       assert_eq2 = n1
    ELSE
       WRITE(*,*) "Error: an assert_eq failed with this tag:", string
       STOP " Program terminated by assert_eq2."
    END IF
    RETURN
  END FUNCTION assert_eq2
!
  FUNCTION assert_eq3(n1,n2,n3,string)
!    USE define_types
    IMPLICIT NONE
    CHARACTER(len=*), INTENT(in) :: string
    INTEGER, INTENT(in) :: n1, n2, n3
    INTEGER :: assert_eq3
    IF(n1 == n2 .AND. n2 == n3) THEN
       assert_eq3 = n1
    ELSE
       WRITE(*,*) "Error: an assert_eq failed with this tag:",string
       STOP " Program terminated by assert_eq3."
    END IF
    RETURN
  END FUNCTION assert_eq3
!
  FUNCTION assert_eq4(n1,n2,n3,n4,string)
!    USE define_types
    IMPLICIT NONE
    CHARACTER(len=*), INTENT(in) :: string
    INTEGER, INTENT(in) :: n1, n2, n3, n4
    INTEGER :: assert_eq4
    IF(n1 == n2 .AND. n2 == n3 .AND. n3 == n4) THEN
       assert_eq4 = n1
    ELSE
       WRITE(*,*) "Error: an assert_eq failed with this tag:",string
       STOP " Program terminated by assert_eq4."
    END IF
    RETURN
  END FUNCTION assert_eq4
!
  FUNCTION assert_eqn(nn,string)
!    USE define_types
    IMPLICIT NONE
    CHARACTER(len=*), INTENT(in) :: string
    INTEGER, DIMENSION(:), INTENT(in) :: nn
    INTEGER :: assert_eqn
    IF(ALL(nn(2:) == nn(1))) THEN
       assert_eqn = nn(1)
    ELSE
       WRITE(*,*) "Error: an assert_eq failed with this tag:",string
       STOP " Program terminated by assert_eqn."
    END IF
    RETURN
  END FUNCTION assert_eqn
!
  SUBROUTINE error(string)
!***********************************************************************
!   Report a message, then die.
!***********************************************************************
!    USE define_types
    IMPLICIT NONE
    CHARACTER(len=*), INTENT(in) :: string
    WRITE(*,*) "Error: ", string
    STOP " Program terminated by error."
    RETURN
  END SUBROUTINE error
!
  SUBROUTINE i_sort(n,x_in,indices,x_out)
!    USE define_types
!***********************************************************************
!
!   FORTRAN 90 SUBROUTINE to sort an array x_in, maintaining original
!   subscripts in indices and RETURN the sorted values in the array x_out.
!
!   Input: n - an INTEGER containing the length of x_in,
!          x_in - the DOUBLE PRECISION vector of length n to be sorted,
!          indices - an INTEGER vector of length n containing original
!                subscripts.
!
!   Output: indices - an INTEGER vector containing the subscripts of the
!                 unsorted vector x_in
!           x_out - a DOUBLE PRECISION vector of length n containing the
!               sorted values of the vector x_in.
!
!   Subprograms called: NONE.
!
!***********************************************************************
    IMPLICIT none
    INTEGER, INTENT(in) :: n
    INTEGER, DIMENSION(n), INTENT(inout) :: indices
    INTEGER, DIMENSION(n), INTENT(in) :: x_in
    INTEGER, DIMENSION(n), INTENT(out) :: x_out
    INTEGER :: m, j, i
!
    m = n
    IF(m .LE. 1) RETURN
!
    DO j = 1, m
       x_out(j) = x_in(j)
       indices(j) = j
    END DO
!
80  m = m - 1
    IF(m.EQ.0) GOTO 90
!
    i = 0
70  i = i + 1
    IF(i .GT. m) GOTO 80
    IF(x_out(i) .LT. x_out(i+1)) GOTO 70
!
    CALL swap(x_out(i),x_out(i+1))
    CALL swap(indices(i),indices(i+1))
!
    GOTO 70
!
90  RETURN
  END SUBROUTINE i_sort
!
  SUBROUTINE r_sort(n,x_in,indices,x_out)
!    USE define_types
!***********************************************************************
!
!   FORTRAN 90 SUBROUTINE to sort an array x_in, maintaining original
!   subscripts in indices and RETURN the sorted values in the array x_out.
!
!   Input: n - an INTEGER containing the length of x_in,
!          x_in - the DOUBLE PRECISION vector of length n to be sorted,
!          indices - an INTEGER vector of length n containing original
!                subscripts.
!
!   Output: indices - an INTEGER vector containing the subscripts of the
!                 unsorted vector x_in
!           x_out - a DOUBLE PRECISION vector of length n containing the
!               sorted values of the vector x_in.
!
!   Subprograms called: NONE.
!
!***********************************************************************
    IMPLICIT none
    INTEGER, INTENT(in) :: n
    INTEGER, DIMENSION(n), INTENT(inout) :: indices
    REAL, DIMENSION(n), INTENT(in) :: x_in
    REAL, DIMENSION(n), INTENT(out) :: x_out
    INTEGER :: m, j, i
!
    m = n
    IF(m .LE. 1) RETURN
!
    DO j = 1, m
       x_out(j) = x_in(j)
       indices(j) = j
    END DO
!
80  m = m - 1
    IF(m.EQ.0) GOTO 90
!
    i = 0
70  i = i + 1
    IF(i .GT. m) GOTO 80
    IF(x_out(i) .LT. x_out(i+1)) GOTO 70
!
    CALL swap(x_out(i),x_out(i+1))
    CALL swap(indices(i),indices(i+1))
!
    GOTO 70
!
90  RETURN
  END SUBROUTINE r_sort
!
  SUBROUTINE d_sort(n,x_in,indices,x_out)
!    USE define_types
!***********************************************************************
!
!   FORTRAN 90 SUBROUTINE to sort an array x_in, maintaining original
!   subscripts in indices and RETURN the sorted values in the array x_out.
!
!   Input: n - an INTEGER containing the length of x_in,
!          x_in - the DOUBLE PRECISION vector of length n to be sorted,
!          indices - an INTEGER vector of length n containing original
!                subscripts.
!
!   Output: indices - an INTEGER vector containing the subscripts of the
!                 unsorted vector x_in
!           x_out - a DOUBLE PRECISION vector of length n containing the
!               sorted values of the vector x_in.
!
!   Subprograms called: NONE.
!
!***********************************************************************
    IMPLICIT none
    INTEGER, INTENT(in) :: n
    INTEGER, DIMENSION(n), INTENT(inout) :: indices
    REAL, DIMENSION(n), INTENT(in) :: x_in
    REAL, DIMENSION(n), INTENT(out) :: x_out
    INTEGER :: m, j, i
!
    m = n
    IF(m .LE. 1) RETURN
!
    DO j = 1, m
       x_out(j) = x_in(j)
       indices(j) = j
    END DO
!
80  m = m - 1
    IF(m.EQ.0) GOTO 90
!
    i = 0
70  i = i + 1
    IF(i .GT. m) GOTO 80
    IF(x_out(i) .LT. x_out(i+1)) GOTO 70
!
    CALL swap(x_out(i),x_out(i+1))
    CALL swap(indices(i),indices(i+1))
!
    GOTO 70
!
90  RETURN
  END SUBROUTINE d_sort
!
END MODULE f90_utilities

MODULE f90_interfaces
!***********************************************************************
!  FORTRAN 90 module containing interfaces for f90_utilities.
!***********************************************************************
  INTERFACE
     SUBROUTINE swap_i(a,b)
!       USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(inout) :: a,b
     END SUBROUTINE swap_i
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_r(a,b)
!       USE define_types
       IMPLICIT NONE
       REAL, INTENT(inout) :: a,b
     END SUBROUTINE swap_r
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_d(a,b)
!       USE define_types
       IMPLICIT NONE
       REAL, INTENT(inout) :: a,b
     END SUBROUTINE swap_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_dv(a,b)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(inout) :: a,b
     END SUBROUTINE swap_dv
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_c(a,b)
!       USE define_types
       IMPLICIT NONE
       COMPLEX, INTENT(inout) :: a, b
     END SUBROUTINE swap_c
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_cv(a,b)
!       USE define_types
       IMPLICIT NONE
       COMPLEX, DIMENSION(:), INTENT(inout) :: a, b
     END SUBROUTINE swap_cv
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_cm(a,b)
!       USE define_types
       IMPLICIT NONE
       COMPLEX, DIMENSION(:,:), INTENT(inout) :: a, b
     END SUBROUTINE swap_cm
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_z(a,b)
!       USE define_types
       IMPLICIT NONE
       COMPLEX, INTENT(inout) :: a, b
     END SUBROUTINE swap_z
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_zv(a,b)
!       USE define_types
       IMPLICIT NONE
       COMPLEX, DIMENSION(:), INTENT(inout) :: a, b
     END SUBROUTINE swap_zv
  END INTERFACE
!
  INTERFACE
     SUBROUTINE swap_zm(a,b)
!       USE define_types
       IMPLICIT NONE
       COMPLEX, DIMENSION(:,:), INTENT(inout) :: a, b
     END SUBROUTINE swap_zm
  END INTERFACE
!
  INTERFACE
     SUBROUTINE masked_swap_rs(a,b,mask)
!       USE define_types
       IMPLICIT NONE
       REAL, INTENT(inout) :: a, b
       LOGICAL, INTENT(in) :: mask
     END SUBROUTINE masked_swap_rs
  END INTERFACE
!
  INTERFACE
     SUBROUTINE masked_swap_rv(a,b,mask)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(inout) :: a, b
       LOGICAL, DIMENSION(:), INTENT(in) :: mask
     END SUBROUTINE masked_swap_rv
  END INTERFACE
!
  INTERFACE
     SUBROUTINE masked_swap_rm(a,b,mask)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(inout) :: a, b
       LOGICAL, DIMENSION(:,:), INTENT(in) :: mask
     END SUBROUTINE masked_swap_rm
  END INTERFACE
!
  INTERFACE
     SUBROUTINE masked_swap_rd(a,b,mask)
!       USE define_types
       IMPLICIT NONE
       REAL, INTENT(inout) :: a, b
       LOGICAL, INTENT(in) :: mask
     END SUBROUTINE masked_swap_rd
  END INTERFACE
!
  INTERFACE
     SUBROUTINE masked_swap_dv(a,b,mask)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(inout) :: a, b
       LOGICAL, DIMENSION(:), INTENT(in) :: mask
     END SUBROUTINE masked_swap_dv
  END INTERFACE
!
  INTERFACE
     SUBROUTINE masked_swap_dm(a,b,mask)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(inout) :: a, b
       LOGICAL, DIMENSION(:,:), INTENT(in) :: mask
     END SUBROUTINE masked_swap_dm
  END INTERFACE
!
  INTERFACE 
     SUBROUTINE mat_mult_s(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(in) :: a, b
       REAL, DIMENSION(:,:), INTENT(out) :: c
       EXTERNAL sgemm
     END SUBROUTINE mat_mult_s
  END INTERFACE
!
  INTERFACE 
     SUBROUTINE mat_mult_d(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(in) :: a, b
       REAL, DIMENSION(:,:), INTENT(out) :: c
       EXTERNAL dgemm
     END SUBROUTINE mat_mult_d
  END INTERFACE
!
  INTERFACE 
     SUBROUTINE vv_mult_s(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(in) :: a, b
       REAL, INTENT(out) :: c
       REAL :: sdot
       EXTERNAL sdot
     END SUBROUTINE vv_mult_s
  END INTERFACE
!
  INTERFACE 
     SUBROUTINE vv_mult_d(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(in) :: a, b
       REAL, INTENT(out) :: c
       REAL :: ddot
       EXTERNAL ddot
     END SUBROUTINE vv_mult_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE vm_mult_s(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(in) :: a
       REAL, DIMENSION(:,:), INTENT(in) :: b
       REAL, DIMENSION(:,:), INTENT(out) :: c
       EXTERNAL sgemm
     END SUBROUTINE vm_mult_s
  END INTERFACE
!
  INTERFACE
     SUBROUTINE vm_mult_d(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:), INTENT(in) :: a
       REAL, DIMENSION(:,:), INTENT(in) :: b
       REAL, DIMENSION(:,:), INTENT(out) :: c
       EXTERNAL dgemm
     END SUBROUTINE vm_mult_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE mv_mult_s(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(in) :: a
       REAL, DIMENSION(:), INTENT(in) :: b
       REAL, DIMENSION(:), INTENT(out) :: c
       EXTERNAL sgemv
     END SUBROUTINE mv_mult_s
  END INTERFACE
!
  INTERFACE
     SUBROUTINE mv_mult_d(a,b,c)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(in) :: a
       REAL, DIMENSION(:), INTENT(in) :: b
       REAL, DIMENSION(:), INTENT(out) :: c
       EXTERNAL dgemv
     END SUBROUTINE mv_mult_d
  END INTERFACE
!
!!INTERFACE
!!!  SUBROUTINE vech_r(a,b,n,ndim,m,mdim,k,option,v)
!       USE define_types
!!!    IMPLICIT NONE
!!!    INTEGER, INTENT(in) :: n, ndim, m, mdim, k, option
!!!    REAL, DIMENSION(ndim), INTENT(in) :: a
!!!    REAL, DIMENSION(1,mdim), INTENT(in) :: b
!!!    REAL, DIMENSION(k**2), INTENT(inout) :: v
!!!  END SUBROUTINE vech_r
!!END INTERFACE
!
  INTERFACE
     SUBROUTINE vech_d(a,b,n,ndim,m,mdim,k,option,v)
!       USE define_types
       IMPLICIT NONE
       INTEGER, INTENT(in) :: n, ndim, m, mdim, k, option
       REAL, DIMENSION(ndim), INTENT(in) :: a
       REAL, DIMENSION(1,mdim), INTENT(in) :: b
       REAL, DIMENSION(k**2), INTENT(inout) :: v
     END SUBROUTINE vech_d
  END INTERFACE
!
  INTERFACE
     SUBROUTINE cholesky_fac_r(x,u)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(in) :: x
       REAL, DIMENSION(SIZE(x,1),SIZE(x,2)), INTENT(out) :: u
       EXTERNAL spotrf
     END SUBROUTINE cholesky_fac_r
  END INTERFACE
!
  INTERFACE
     SUBROUTINE cholesky_fac_d(x,u)
!       USE define_types
       IMPLICIT NONE
       REAL, DIMENSION(:,:), INTENT(in) :: x
       REAL, DIMENSION(SIZE(x,1),SIZE(x,2)), INTENT(out) :: u
       EXTERNAL dpotrf
     END SUBROUTINE cholesky_fac_d
  END INTERFACE
!
  INTERFACE
     FUNCTION assert_eq2(n1,n2,string)
!       USE define_types
       IMPLICIT NONE
       CHARACTER(len=*), INTENT(in) :: string
       INTEGER, INTENT(in) :: n1, n2
       INTEGER :: assert_eq2
     END FUNCTION assert_eq2
  END INTERFACE
!
  INTERFACE
     FUNCTION assert_eq3(n1,n2,n3,string)
!       USE define_types
       IMPLICIT NONE
       CHARACTER(len=*), INTENT(in) :: string
       INTEGER, INTENT(in) :: n1, n2, n3
       INTEGER :: assert_eq3
     END FUNCTION assert_eq3
  END INTERFACE
!
  INTERFACE
     FUNCTION assert_eq4(n1,n2,n3,n4,string)
!       USE define_types
       IMPLICIT NONE
       CHARACTER(len=*), INTENT(in) :: string
       INTEGER, INTENT(in) :: n1, n2, n3, n4
       INTEGER :: assert_eq4
     END FUNCTION assert_eq4
  END INTERFACE
!
  INTERFACE
     FUNCTION assert_eqn(nn,string)
!       USE define_types
       IMPLICIT NONE
       CHARACTER(len=*), INTENT(in) :: string
       INTEGER, DIMENSION(:), INTENT(in) :: nn
       INTEGER :: assert_eqn
     END FUNCTION assert_eqn
  END INTERFACE
!
  INTERFACE
     SUBROUTINE error(string)
!       USE define_types
       IMPLICIT NONE
       CHARACTER(len=*), INTENT(in) :: string
     END SUBROUTINE error
  END INTERFACE
!
  INTERFACE
     SUBROUTINE i_sort(n,x_in,indices,x_out)
 !      USE define_types
       IMPLICIT none
       INTEGER, INTENT(in) :: n
       INTEGER, INTENT(inout) :: indices
       INTEGER, DIMENSION(n), INTENT(in) :: x_in
       INTEGER, DIMENSION(n), INTENT(out) :: x_out
     END SUBROUTINE i_sort
  END INTERFACE
!
  INTERFACE
     SUBROUTINE r_sort(n,x_in,indices,x_out)
!       USE define_types
       IMPLICIT none
       INTEGER, INTENT(in) :: n
       INTEGER, INTENT(inout) :: indices
       REAL, DIMENSION(n), INTENT(in) :: x_in
       REAL, DIMENSION(n), INTENT(out) :: x_out
     END SUBROUTINE r_sort
  END INTERFACE
!
  INTERFACE
     SUBROUTINE d_sort(n,x_in,indices,x_out)
!       USE define_types
       IMPLICIT none
       INTEGER, INTENT(in) :: n
       INTEGER, INTENT(inout) :: indices
       REAL, DIMENSION(n), INTENT(in) :: x_in
       REAL, DIMENSION(n), INTENT(out) :: x_out
     END SUBROUTINE d_sort
  END INTERFACE
END MODULE f90_interfaces


SUBROUTINE fcar_test(max_n,max_k,n,k,rtrim,res0,res1,rss0,rss1,rss0_det,  &
    rss1_det,test_statistic)
!-----------------------------------------------------------------------
!  FORTRAN90 subroutine to compute lack-of-fit test statistic
!
!  Written: 01/22/04 JLH
!-----------------------------------------------------------------------
!  USE define_types
!
  IMPLICIT NONE
  INTEGER, INTENT(in) :: max_n, max_k, n, k
  REAL, INTENT(in) :: rtrim
  REAL, INTENT(inout) :: rss0_det, rss1_det
  REAL, INTENT(in), DIMENSION(max_n, k) :: res0, res1
  REAL, INTENT(inout) :: test_statistic
  REAL, INTENT(inout), DIMENSION(max_k, k) :: rss0, rss1
!
  INTEGER :: dim, info, upper_lim, lower_lim, nn, index, i, j, t
  REAL :: lambda, perc
  INTEGER, DIMENSION(k) :: pivot
  REAL, DIMENSION(k, k) :: temp0, temp1
  REAL, DIMENSION(n, k) :: ures0, ures1
!
  IF(perc .GT. 0.0) THEN
     perc = (100.0 - DBLE(rtrim))/100.0
     upper_lim = perc*n
     perc = 1.0 - perc
     lower_lim = perc*n + 1
     nn = upper_lim - lower_lim
     DO i = 1, nn
        index = lower_lim + i - 1
        ures0(i, 1:k) = res0(index, 1:k)
        ures1(i, 1:k) = res1(index, 1:k)
     END DO
  ELSE
     nn = n
     lower_lim = 1
     upper_lim = n
     ures0(1:n, 1:k) = res0(1:n, 1:k)
     ures1(1:n, 1:k) = res1(1:n, 1:k)
  END IF
!
  rss0_det = 0.0
  rss1_det = 0.0
  IF(k == 1) THEN
     DO t = 1, nn
        rss0_det = rss0_det + ures0(t,1)*ures0(t,1)
        rss1_det = rss1_det + ures1(t,1)*ures1(t,1)
     END DO
  ELSE
!print *, " shape ures0=", shape(ures0)
!print *, " shape Tr(ures0)=", shape(TRANSPOSE(ures0))
     rss0(1:k,1:k) = MATMUL(TRANSPOSE(ures0(1:nn,1:k)),ures0(1:nn,1:k))
!print *, "MATMUL 1 in fcar_test.f90: OK"
     rss1(1:k,1:k) = MATMUL(TRANSPOSE(ures1(1:nn,1:k)),ures1(1:nn,1:k))
!print *, "MATMUL 2 in fcar_test.f90: OK"
     DO dim = 1, k
        rss0_det = rss0_det + rss0(dim,dim)
        rss1_det = rss1_det + rss1(dim,dim)
     END DO
  END IF
  write(100,*) 'before lambda',rss1_det,rss0_det
  lambda = SQRT(rss1_det/rss0_det)
  write(100,*) 'after lambda'
  test_statistic = (1.0 - SQRT(lambda))/SQRT(lambda)
! 
  RETURN
END SUBROUTINE fcar_test

SUBROUTINE fit_fcar(max_n,n, k,p,y,x,band_width,u,z,smoother,start,grid,f_dim,f_hat)
!     CALL fit_fcar(max_n,n1,k,p,y,x,h,         u,z,smoother, n1,  m,f_dim,f_hat)

!  USE define_types
!  USE stat_utilities
!  USE f90_utilities
!***********************************************************************
!   FOTRAN 90 subroutine to fit a functional coefficient autoregressive
!   model to multivariate data.
!
!   Notes: Uses LAPACK subroutines DGETRF to get LU factorization and 
!          DGETRI to get inverse of matrix.  Both available from free
!          download from http://www.netlib.org/lapack/.
!          Uses BLAS subroutine DGEMM to multiply matrices.  Available
!          for free download from http://www.netlib.org/blas/.
!***********************************************************************
  IMPLICIT NONE
  INTEGER, INTENT(in) :: max_n, n, k, p, f_dim, smoother, grid, start
  REAL, INTENT(in) :: band_width
  REAL, INTENT(in), DIMENSION(max_n) :: u, z
  REAL, INTENT(in), DIMENSION(max_n, k) :: y
  REAL, INTENT(in), DIMENSION(max_n, p) :: x
  REAL, INTENT(inout), DIMENSION(max_n, f_dim, k) :: f_hat
!
  INTEGER :: t, i, j, info, p2, index_of_f, l,jj,ii
  INTEGER, DIMENSION(2*p) :: pivot
  INTEGER, DIMENSION(n) :: u_index
  REAL :: s
  REAL, DIMENSION(n+start+grid+1) :: w0, work
  REAL, DIMENSION((2*p), (2*p)) :: s0, temp
  REAL, DIMENSION((2*p), k) :: s1, s2
  REAL, DIMENSION(n, (2*p)) :: dx, work_space
  REAL, DIMENSION(n, k) :: wy
  REAL, DIMENSION(max_n, f_dim, k) :: temp_f
  REAL :: cubic_sm_r
  REAL :: quartic_sm_r
  REAL :: Epanechnikov_r
!
  EXTERNAL dgetrf
  EXTERNAL dgetri
!
  p2 = 2*p
  s0 = 0.0
  s1 = 0.0
  
  DO i = 1, p2
     s0(i,i) = 1.0
  END DO
  write(100,*)
  
  dx(1:n, 1:p) = x(1:n, 1:p)
    write(100,*) 'p in fcar', p,start,grid,n,band_width,smoother,p2
    write(100,*)
  DO i = start+1, start+grid
     DO t = 1, n
        IF(smoother == 1) THEN
           w0(t) = quartic_sm_r((u(t) - z(i))/band_width)
        ELSE IF(smoother == 2) THEN
           w0(t) = Epanechnikov_r((u(t) - z(i))/band_width)
        ELSE IF(smoother == 3) THEN
           w0(t) = cubic_sm_r((u(t) - z(i))/band_width)
!           write(100,*) 'w0 within smoother 3', w0(t),u(t),t
        END IF
        w0(t) = w0(t) / band_width
!        write(100,*) 'w0 in fcar', w0(t),u(t),z(i),i,t,p
        
        work_space(t,1:p) = w0(t) * dx(t,1:p)
        write(100,*) (work_space(t,jj),jj=1,p)  
        
        dx(t,(p+1):p2) = (u(t) - z(i))*x(t,1:p)
!        write(100,*) (dx(t,jj),jj=(p+1),p2)
      
        work_space(t,(p+1):p2) = w0(t)*dx(t,(p+1):p2)
!!        write(100,*) (work_space(t,jj),jj=p+1,p2)
     END DO
     write(100,*) 'before temp'
     
     temp = MATMUL(TRANSPOSE(dx),work_space)
     do ii=1,6
        write(100,*) (temp(ii,j),j=1,6)
     end do
     
     write(100,*) 's0'
     s0 = (1.0d0/DBLE(n*n))*s0 + temp
     
     do ii=1,6
        write(100,*) (s0(ii,j),j=1,6)
     end do   
     write(100,*)
     
     
     CALL dgetrf(p2,p2,s0,p2,pivot,info)
     
     do ii=1,2*p
        write(100,*) (s0(ii,j),j=1,2*p)
     end do       
     
     CALL dgetri(p2,s0,p2,pivot,work,n,info)
     DO t = 1, n
        wy(t,1:k) = w0(t)* y(t,1:k)
        write(100,*) wy(t,1:k)
     END DO
     s1 = MATMUL(TRANSPOSE(dx),wy)
     s2 = MATMUL(s0,s1)
     f_hat(i,1:p,1:k) = s2(1:p,1:k)
!     write(100,*) 'f_hat', f_hat(i,1:p,1:k),i,p,k
  END DO
!
RETURN
END SUBROUTINE fit_fcar

  SUBROUTINE swap_i(a,b)
!    USE define_types
    IMPLICIT NONE
    INTEGER, INTENT(inout) :: a, b
    INTEGER :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_i


  SUBROUTINE i_sort(n,x_in,indices,x_out)
!    USE define_types
!***********************************************************************
!
!   FORTRAN 90 SUBROUTINE to sort an array x_in, maintaining original
!   subscripts in indices and RETURN the sorted values in the array x_out.
!
!   Input: n - an INTEGER containing the length of x_in,
!          x_in - the DOUBLE PRECISION vector of length n to be sorted,
!          indices - an INTEGER vector of length n containing original
!                subscripts.
!
!   Output: indices - an INTEGER vector containing the subscripts of the
!                 unsorted vector x_in
!           x_out - a DOUBLE PRECISION vector of length n containing the
!               sorted values of the vector x_in.
!
!   Subprograms called: NONE.
!
!***********************************************************************
    IMPLICIT none
    INTEGER, INTENT(in) :: n
    INTEGER, DIMENSION(n), INTENT(inout) :: indices
    REAL, DIMENSION(n), INTENT(in) :: x_in
    REAL, DIMENSION(n), INTENT(out) :: x_out
    INTEGER :: m, j, i
!
    m = n
    IF(m .LE. 1) RETURN
!
    DO j = 1, m
       x_out(j) = x_in(j)
       indices(j) = j
    END DO
!
80  m = m - 1
    IF(m.EQ.0) GOTO 90
!
    i = 0
70  i = i + 1
    IF(i .GT. m) GOTO 80
    IF(x_out(i) .LT. x_out(i+1)) GOTO 70
!
    CALL swap_r(x_out(i),x_out(i+1))
    CALL swap_i(indices(i),indices(i+1))
!
    GOTO 70
!
90  RETURN
  END SUBROUTINE i_sort
!


  SUBROUTINE swap_r(a,b)
!    USE define_types
    IMPLICIT NONE
    REAL, INTENT(inout) :: a, b
    REAL :: temp
    temp = a
    a = b
    b = temp
    RETURN
  END SUBROUTINE swap_r
!

!***********************************************************************
!   Half-stacking vector subroutines:
!***********************************************************************
!***********************************************************************
!   FORTRAN subroutine to calculate the stacking or half-stacking
!   vector, v, of the product of two vectors, a and b.
!
!   Input: a = a double precision matrix of dimension n x m.
!          b = a double precision matrix of dimension m x k.
!          option = an integer indicating whether to take the half-
!                   stacking vector (iopt = 0) or the stacking vector
!                   (iopt = 1).
!          n = an integer containing the number of columns of a.
!          k = an integer containing the number of rows of b.
!
!   Output: v = a double precision vector containing the half-stacking
!               or stacking vector of a and b.  If iopt = 0, the 
!               length of y is (nk)[(nk)+1]/2.  If iopt = 1, the 
!               length of z is nk.
!***********************************************************************
  SUBROUTINE vech_r(a,b,n,ndim,m,mdim,k,option,v)
!    USE define_types
    IMPLICIT NONE
    INTEGER, INTENT(in) :: n, ndim, m, mdim, k, option
    REAL, DIMENSION(ndim), INTENT(in) :: a
    REAL, DIMENSION(1,mdim), INTENT(in) :: b
    REAL, DIMENSION(k**2), INTENT(inout) :: v
!  
    INTEGER :: lower_limit, vindex, i, j
!
    v = 0.0
!
    lower_limit = 1
    vindex = 0
!
    DO i = 1, k
       IF(option == 0) lower_limit = i
       DO j = lower_limit, n
          vindex = vindex + 1
          v(vindex) = a(j)*b(1,i)
       END DO
    END DO
    RETURN
  END SUBROUTINE vech_r


!***********************************************************************
!  Linear regression:
!***********************************************************************
!  Notes: Uses LAPACK subroutines sgetrf and sgetri for computing
!         LU factorization and matrix inversion.  See
!         http://www.netlib.org/lapack/
!***********************************************************************
  SUBROUTINE ls_regr_r(max_n,n,p,x,y,beta_hat)
!    USE define_types
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, n, p
    REAL, INTENT(in), DIMENSION(n) :: y
    REAL, INTENT(in), DIMENSION(max_n, p) :: x
    REAL, INTENT(out), DIMENSION(p) :: beta_hat
!
    INTEGER :: info
    INTEGER, DIMENSION(:), ALLOCATABLE :: pivot
    REAL, DIMENSION(:), ALLOCATABLE :: xty
    REAL, DIMENSION(:,:), ALLOCATABLE :: xtx
    REAL, DIMENSION(:), ALLOCATABLE :: work_space
!
    EXTERNAL sgetrf
    EXTERNAL sgetri
!
    ALLOCATE(xtx(p,p))
    ALLOCATE(xty(p))
    xtx = MATMUL(TRANSPOSE(x(1:n,1:p)),x(1:n,1:p))
    xty = MATMUL(TRANSPOSE(x(1:n,1:p)),y(1:n))
!
    ALLOCATE(pivot(p))
    ALLOCATE(work_space(p))
    CALL sgetrf(p,p,xtx,p,pivot,info)
    CALL sgetri(p,xtx,p,pivot,work_space,p,info)
    DEALLOCATE(pivot, work_space)
!
    beta_hat(1:p) = MATMUL(xtx(1:p,1:p),xty(1:p))
!
!print *, "MATMUL (2) in stat_utilities.f90/ls_regr_r(): OK"
    DEALLOCATE(xtx, xty)
    RETURN
  END SUBROUTINE ls_regr_r

  SUBROUTINE ls_regr_rmv(max_n,n,k,p,x,y,beta_dim,beta_hat)
!    USE define_types
!
    IMPLICIT NONE
    INTEGER, INTENT(in) :: max_n, n, k, beta_dim, p
    REAL, INTENT(in), DIMENSION(max_n, p) :: x
    REAL, INTENT(in), DIMENSION(max_n, k) :: y
    REAL, INTENT(inout), DIMENSION(beta_dim, k) :: beta_hat
!
    INTEGER :: info
    INTEGER, DIMENSION(:), ALLOCATABLE :: pivot
    REAL, DIMENSION(:), ALLOCATABLE :: work_space
    REAL, DIMENSION(:,:), ALLOCATABLE :: xtx, xty
!
    EXTERNAL sgetrf
    EXTERNAL sgetri
!
    ALLOCATE(xtx(p,p))
    ALLOCATE(xty(p,k))
    xtx = MATMUL(TRANSPOSE(x(1:n,1:p)),x(1:n,1:p))
    xty = MATMUL(TRANSPOSE(x(1:n,1:p)),y(1:n,1:k))
!
    ALLOCATE(pivot(p))
    ALLOCATE(work_space(p))
    CALL sgetrf(p,p,xtx,p,pivot,info)
    CALL sgetri(p,xtx,p,pivot,work_space,p,info)
    DEALLOCATE(pivot, work_space)
!
    beta_hat(1:p,1:k) = MATMUL(xtx(1:p,1:p),xty(1:p,1:k))
!print *, "MATMUL (3) in stat_utilities.f90/ls_regr_rmv(): OK"
!
    DEALLOCATE(xtx, xty)
    RETURN
!
  END SUBROUTINE ls_regr_rmv

  SUBROUTINE gen_mvnormal_r(max_n,max_k,n,k,mean,cov,cov_fac_option,x)
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: max_n, max_k, n, k, cov_fac_option
    REAL, INTENT(in), DIMENSION(k) :: mean
    REAL, INTENT(in), DIMENSION(max_k, k) :: cov
    REAL, INTENT(out), DIMENSION(max_n, k) :: x
!
    INTEGER :: info, i, j
    REAL, DIMENSION(:), ALLOCATABLE :: temp, temp_out
    REAL, DIMENSION(:,:), ALLOCATABLE :: cov_fac
!
    EXTERNAL spotrf
!
    ALLOCATE(cov_fac(k,k))
    cov_fac = cov
    DO i = 1, k
    DO j = 1, i-1
       cov_fac(i,j) = 0.0
    END DO
    END DO
!
    IF(cov_fac_option .NE. 0) CALL spotrf("U",k,cov_fac,k,info)
!
    ALLOCATE(temp(k))
    ALLOCATE(temp_out(k))
    DO i = 1,n
       CALL gen_normal_r(0.0,1.0,k,temp)
       temp = MATMUL(TRANSPOSE(cov_fac),temp)
       x(i,1:k) = temp_out + mean(1:k)
       write(100,*) 'mvnormal', x(i,1:k),i,k
    END DO
    DEALLOCATE(temp, temp_out, cov_fac)
!
!print *, "MATMUL in stat_utilities.f90/gen_mvnormal_r(): OK"
    RETURN
  END SUBROUTINE gen_mvnormal_r
!
  SUBROUTINE gen_normal_r(mean,variance,n,x)
!***********************************************************************
!  FORTRAN 90 subroutine to generate n N(mean,variance)
!  random variates.
!***********************************************************************
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: n
    REAL, INTENT(in) :: mean, variance
    REAL, INTENT(out), DIMENSION(n) :: x
!
    INTEGER :: nn, nnb2, i, i1, i2
    REAL :: s, y
    REAL, DIMENSION(2) :: r
!  
    nn = n - 1
    IF(2*(n/2) .EQ. n) nn = n
    IF(n .EQ. nn) go to 20
!
5   CALL gen_uniform_r(0.0,1.0,2,r)
    !
    r = 2.0*(r - 0.50)
    s = DOT_PRODUCT(r,r)
    !
    IF(s .GT. 1.0) go to 5
    y = SQRT(-2.0*(LOG(s)/s))
    !
    x(n) = r(1)*y
    IF(n .EQ. 1) go to 99
    !
20  CALL gen_uniform_r(0.0,1.0,nn,x)
    nnb2 = nn/2
    !
    DO i = 1, nnb2
       i2 = 2*i
       i1 = i2 - 1
12     r(1) = 2.0 * (x(i1) - 0.50)
       r(2) = 2.0 * (x(i2) - 0.50)
       s = DOT_PRODUCT(r,r)
       IF(s .LE. 1.0) go to 15
       CALL gen_uniform_r(0.0,1.0,2,x(i1:i2))
       go to 12
15     y = SQRT(-2.0 * (LOG(s)/s))
       x(i1) = y*r(1)
       x(i2) = y*r(2)
    END DO
    x = SQRT(variance)*x + mean
!
99  CONTINUE
    RETURN
!
  END SUBROUTINE gen_normal_r
!
  SUBROUTINE gen_uniform_r(a,b,n,x)
!***********************************************************************
!  FORTRAN 90 subroutine to generate n uniform(a,b) random variates.
!***********************************************************************
!    USE define_types
!
    IMPLICIT NONE
!
    INTEGER, INTENT(in) :: n
    REAL, INTENT(in) :: a, b
    REAL, INTENT(out), DIMENSION(n) :: x
!
    INTEGER :: i
    REAL :: c
!
    DO i = 1,n
       CALL RANDOM_NUMBER(c)
       x(i) = (b - a)*c + a
    END DO
!
    RETURN
  END SUBROUTINE gen_uniform_r

  FUNCTION cubic_sm_r(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: cubic_sm_r
!
    IF(ABS(x) .LE. 1.0) THEN
       cubic_sm_r = 0.75*(1.0 - x*x)
    ELSE
       cubic_sm_r = 0.0
    END IF
!
    RETURN
  END FUNCTION cubic_sm_r

  FUNCTION quartic_sm_r(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: quartic_sm_r
!
    IF(ABS(x) .LE. 1.0) THEN
       quartic_sm_r = 0.9375*(1.0 - x*x)*(1.0 - x*x)
    ELSE
       quartic_sm_r = 0.0
    END IF
!
    RETURN
  END FUNCTION quartic_sm_r

!************************************************************************
!     Epanechnikov:
!***********************************************************************
  FUNCTION Epanechnikov_r(x)
!    USE define_types
!
    IMPLICIT NONE
    REAL, INTENT(in) :: x
    REAL :: Epanechnikov_r
!
    IF((x*x) .LE. 0.5) THEN
       Epanechnikov_r = 3.0 * (1.0 - x**(2.0/5.0))
       Epanechnikov_r = Epanechnikov_r / (4.0*SQRT(5.0))
    ELSE
       Epanechnikov_r = 0.0
    END IF
!
    RETURN
  END FUNCTION Epanechnikov_r
