SUBROUTINE fcar_test(max_n,max_k,n,k,rtrim,res0,res1,rss0,rss1,rss0_det,  &
    rss1_det,test_statistic)
!-----------------------------------------------------------------------
!  FORTRAN90 subroutine to compute lack-of-fit test statistic
!
!  Written: 01/22/04 JLH
!-----------------------------------------------------------------------
  USE define_types
!
  IMPLICIT NONE
  INTEGER(i4b), INTENT(in) :: max_n, max_k, n, k
  REAL(dp), INTENT(in) :: rtrim
  REAL(dp), INTENT(inout) :: rss0_det, rss1_det
  REAL(dp), INTENT(in), DIMENSION(max_n, k) :: res0, res1
  REAL(dp), INTENT(inout) :: test_statistic
  REAL(dp), INTENT(inout), DIMENSION(max_k, k) :: rss0, rss1
!
  INTEGER(i4b) :: dim, info, upper_lim, lower_lim, nn, index, i, j, t
  REAL(dp) :: lambda, perc
  INTEGER(i4b), DIMENSION(k) :: pivot
  REAL(dp), DIMENSION(k, k) :: temp0, temp1
  REAL(dp), DIMENSION(n, k) :: ures0, ures1
!
  IF(perc .GT. 0.0_dp) THEN
     perc = (100.0_dp - DBLE(rtrim))/100.0_dp
     upper_lim = perc*n
     perc = 1.0_dp - perc
     lower_lim = perc*n + 1
     nn = upper_lim - lower_lim
     DO i = 1, nn
        index = lower_lim + i - 1
        ures0(i, 1:k) = res0(index, 1:k)
        ures1(i, 1:k) = res1(index, 1:k)
     END DO
  ELSE
     nn = n
     lower_lim = 1
     upper_lim = n
     ures0(1:n, 1:k) = res0(1:n, 1:k)
     ures1(1:n, 1:k) = res1(1:n, 1:k)
  END IF
!
  rss0_det = 0.0_dp
  rss1_det = 0.0_dp
  IF(k == 1) THEN
     DO t = 1, nn
        rss0_det = rss0_det + ures0(t,1)*ures0(t,1)
        rss1_det = rss1_det + ures1(t,1)*ures1(t,1)
     END DO
  ELSE
!print *, " shape ures0=", shape(ures0)
!print *, " shape Tr(ures0)=", shape(TRANSPOSE(ures0))
     rss0(1:k,1:k) = MATMUL(TRANSPOSE(ures0(1:nn,1:k)),ures0(1:nn,1:k))
!print *, "MATMUL 1 in fcar_test.f90: OK"
     rss1(1:k,1:k) = MATMUL(TRANSPOSE(ures1(1:nn,1:k)),ures1(1:nn,1:k))
!print *, "MATMUL 2 in fcar_test.f90: OK"
     DO dim = 1, k
        rss0_det = rss0_det + rss0(dim,dim)
        rss1_det = rss1_det + rss1(dim,dim)
     END DO
  END IF
  lambda = SQRT(rss1_det/rss0_det)
  test_statistic = (1.0_dp - SQRT(lambda))/SQRT(lambda)
! 
  RETURN
END SUBROUTINE fcar_test
