MODULE ts_interfaces
!***********************************************************************
!  FORTRAN 90 module containing interfaces for traditional time series
!  analysis programs.
!***********************************************************************
  INTERFACE
     SUBROUTINE get_mvARMA_params(max_k,max_p,max_q,file_label,k,p,q,AR_coefs,MA_coefs)
       USE define_types
       IMPLICIT NONE
       INTEGER(i4b), INTENT(in) :: max_k, max_p, max_q, file_label, k
       INTEGER(i4b), INTENT(out) :: p, q
       REAL(dp), INTENT(inout), DIMENSION(max_p, max_k, max_k) :: AR_coefs
       REAL(dp), INTENT(inout), DIMENSION(max_q, max_k, max_k) :: MA_coefs
     END SUBROUTINE get_mvARMA_params
  END INTERFACE
!
  INTERFACE
     SUBROUTINE gen_mvARMA(max_n,max_k,max_p,max_q,n,k,p,q,AR_coefs,MA_coefs,   &
          cov,cov_fac_option,extra,x)
       USE define_types
       USE stat_utilities
       IMPLICIT NONE
       INTEGER(i4b), INTENT(in) :: max_n, max_k, max_p, max_q
       INTEGER(i4b), INTENT(in) :: n, k, p, q, cov_fac_option, extra
       REAL(dp), INTENT(in), DIMENSION(max_p, max_k, max_k) :: AR_coefs
       REAL(dp), INTENT(in), DIMENSION(max_q, max_k, max_k) :: MA_coefs
       REAL(dp), INTENT(in), DIMENSION(max_k, k) :: cov
       REAL(dp), INTENT(inout), DIMENSION(max_n, k) :: x
     END SUBROUTINE gen_mvARMA
  END INTERFACE
!
  INTERFACE
     SUBROUTINE mvaic(max_n,n,k,x,max_order,orders,aic,bic)
       USE define_types
       USE stat_utilities
       IMPLICIT NONE
       INTEGER(i4b), INTENT(in) :: max_n, n, k, max_order
       REAL(dp), INTENT(in), DIMENSION(max_n, k) :: x
       INTEGER(i4b), INTENT(out), DIMENSION(max_order) :: orders
       REAL(dp), INTENT(out), DIMENSION(max_order) :: aic, bic
       EXTERNAL dgetrf
     END SUBROUTINE mvaic
  END INTERFACE
!
END MODULE ts_interfaces
